//
// Copyright (c) 1997, 2012, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/ad_x86_32.hpp"
#include "opto/matcher.hpp"
#include "opto/opcodes.hpp"

//------------------------- Source -----------------------------------------

//------------------------- Attributes -------------------------------------

// AttributeForm 
static const int op_cost = 0;

// AttributeForm 
static const int ins_cost = 100;

// AttributeForm 
static const int ins_size = 8;

// AttributeForm 
static const int ins_short_branch = 0;

// AttributeForm 
static const int ins_alignment = 1;

//------------------------- Macros -----------------------------------------
#define DFA_PRODUCTION(result, rule, cost)\
  _cost[ (result) ] = cost; _rule[ (result) ] = rule;

#define DFA_PRODUCTION__SET_VALID(result, rule, cost)\
  DFA_PRODUCTION( (result), (rule), (cost) ); STATE__SET_VALID( (result) );

//------------------------- DFA --------------------------------------------
// DFA is a large switch with case statements for each ideal opcode encountered
// in any match rule in the ad file.  Each case has a series of if's to handle
// the match or fail decisions.  The matches test the cost function of that
// rule, and prune any cases which are higher cost for the same reduction.
// In order to generate the DFA we walk the table of ideal opcode/MatchList
// pairs generated by the ADLC front end to build the contents of the case
// statements (a series of if statements).


void  State::_sub_Op_RegI(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NCXREGI, ncxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NADXREGI, nadxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NAXREGI, naxRegI_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGI, eRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, eAXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, eBXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, eCXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, eDXRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, eDIRegI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, eSIRegI_rule, c)
    }
}
void  State::_sub_Op_RegP(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, load_long_RegP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, load_long_indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EBPREGP, eBPRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(PREGP, pRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NABXREGP, nabxRegP_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(NAXREGP, naxRegP_rule, c)
    }
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, eRegP_no_EBP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, indirect_win95_safe_rule, c+100)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGP, eRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, anyRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, eAXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGP, eBXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, eCXRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, eSIRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGP, eDIRegP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    {
      unsigned int c = 0;
    }
}
void  State::_sub_Op_RegF(const Node *n){
    if(         
#line 4593 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 
#line 145 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGF, regF_rule, c)
    }
    if(         
#line 4574 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE < 2 
#line 153 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGFPR, regFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, regFPR1_rule, c)
    }
}
void  State::_sub_Op_RegD(const Node *n){
    if(         
#line 4545 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 
#line 164 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGD, regD_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, regD6_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, regD7_rule, c)
    }
    if(         
#line 4510 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE < 2 
#line 174 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(REGDPR, regDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, regDPR1_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, regDPR2_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, regnotDPR1_rule, c)
    }
}
void  State::_sub_Op_RegL(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EADXREGL_LOW_ONLY, eADXRegL_low_only_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EREGL, eRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, eADXRegL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, eBCXRegL_rule, c)
    }
}
void  State::_sub_Op_RegFlags(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, flagsReg_long_LEGT_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, flagsReg_long_EQNE_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, flagsReg_long_LTGE_rule, c)
    }
    if(         
#line 4482 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
false
#line 212 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, eFlagsRegUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, eFlagsRegU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, eFlagsReg_rule, c)
    }
}
void  State::_sub_Op_AbsD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 725 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 231 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, vabsD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, vabsD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, vabsD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 713 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 242 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, absD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, absD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, absD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9676 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 259 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, absDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, absDPR_reg_rule, c)
    }
}
void  State::_sub_Op_AbsF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 701 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 273 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, vabsF_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 690 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 282 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, absF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) &&
        (
#line 10571 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 293 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR1, absFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, absFPR_reg_rule, c)
    }
}
void  State::_sub_Op_AddD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 252 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 305 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, vaddD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, vaddD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, vaddD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 240 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 316 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vaddD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vaddD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vaddD_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 240 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 333 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vaddD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vaddD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vaddD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 228 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 350 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vaddD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vaddD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vaddD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 217 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 367 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, addD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, addD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 205 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 384 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, addD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, addD_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 205 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 401 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, addD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, addD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 193 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 418 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, addD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, addD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, addD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _MULD_REGDPR_REGDPR) &&
        (
#line 9882 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 435 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_MULD_REGDPR_REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_mulDPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_mulDPR_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGDPR_REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9882 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 447 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGDPR_REGDPR]+_kids[1]->_cost[REGDPR]+250;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_mulDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR_IMMDPR, _AddD_regDPR_immDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) &&
        (
#line 9768 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && _kids[1]->_leaf->getd() != 0.0 && _kids[1]->_leaf->getd() != 1.0 
#line 471 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR1) &&
        (
#line 9755 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 491 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR1]+125;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_imm1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_imm1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR__LOADD_MEMORY_, _AddD_regDPR__LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD__LOADD_MEMORY__REGDPR, _AddD__LoadD_memory__regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9725 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 519 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9725 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 539 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_ADDD_REGDPR_REGDPR, _AddD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9696 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 563 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, addDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, addDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_AddF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 181 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 586 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, vaddF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 169 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 595 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vaddF_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 169 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 606 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vaddF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 157 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 617 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vaddF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 146 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 628 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 134 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 639 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 134 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 650 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 122 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 661 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, addF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF_REGFPR_REGFPR) &&
        (
#line 10843 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 672 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF_REGFPR_REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGFPR_REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10843 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 682 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGFPR_REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF_REGFPR__LOADF_MEMORY_) &&
        (
#line 10821 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 696 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF_REGFPR__LOADF_MEMORY_]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF_REGFPR__LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10821 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 710 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF_REGFPR__LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _MULF__LOADF_MEMORY__REGFPR) &&
        (
#line 10821 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 724 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_MULF__LOADF_MEMORY__REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULF__LOADF_MEMORY__REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10821 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 738 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULF__LOADF_MEMORY__REGFPR]+_kids[1]->_cost[REGFPR]+95;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_mulFPR_reg_load1_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_mulFPR_reg_load1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10680 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 752 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10665 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 766 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_imm_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10650 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 781 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10636 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 798 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_cisc_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10636 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 815 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_cisc_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10622 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 832 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_mem_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10609 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 849 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10609 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 863 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10593 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 877 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10593 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 894 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10559 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 911 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, addFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, addFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10546 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 925 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, addFPR24_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_AddI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SUBI_NCXREGI_NCXREGI) && STATE__VALID_CHILD(_kids[1], _ANDI_NCXREGI__CMPLTMASK_NCXREGI_NCXREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_NCXREGI_NCXREGI]+_kids[1]->_cost[_ANDI_NCXREGI__CMPLTMASK_NCXREGI_NCXREGI]+400;
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_NCXREGI__CMPLTMASK_NCXREGI_NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_NCXREGI_NCXREGI) &&
        /*p*/(_kids[0]->_kids[1]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_NCXREGI__CMPLTMASK_NCXREGI_NCXREGI]+_kids[1]->_cost[_SUBI_NCXREGI_NCXREGI]+400;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBI_NCXREGI_NCXREGI) && STATE__VALID_CHILD(_kids[1], _ANDI__CMPLTMASK_NCXREGI_NCXREGI_NCXREGI) &&
        /*p*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[0]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_SUBI_NCXREGI_NCXREGI]+_kids[1]->_cost[_ANDI__CMPLTMASK_NCXREGI_NCXREGI_NCXREGI]+400;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__CMPLTMASK_NCXREGI_NCXREGI_NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_NCXREGI_NCXREGI) &&
        /*p*/(_kids[0]->_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*q*/(_kids[0]->_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__CMPLTMASK_NCXREGI_NCXREGI_NCXREGI]+_kids[1]->_cost[_SUBI_NCXREGI_NCXREGI]+400;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cadd_cmpLTMask_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI_M1, _AddI__LoadI_memory__immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI1, _AddI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__IMMI, _AddI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ADDI_EREGI__LOADI_MEMORY_, _AddI_eRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_ADDI__LOADI_MEMORY__EREGI, _AddI__LoadI_memory__eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_mem_0_rule, c)
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_mem_0_rule, c)
      }
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) &&
        (
#line 7708 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseIncDec
#line 1046 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, decI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, decI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) &&
        (
#line 7676 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseIncDec
#line 1090 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, incI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, incI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, addI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, addI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, addL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, addL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, addL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_AddP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_SUBI_IMMI0_EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, subP_eReg_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, subP_eReg_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, subP_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, addP_eReg_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, addP_eReg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, addP_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI]+110;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP_eReg_immI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP_eReg_immI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP_eReg_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_NO_EBP__LSHIFTI_EREGI_IMMI2) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_NO_EBP__LSHIFTI_EREGI_IMMI2]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET_WIN95_SAFE, indIndexScaleOffset_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_NO_EBP__LSHIFTI_EREGI_IMMI2, _AddP_eRegP_no_EBP__LShiftI_eRegI_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI2]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE_WIN95_SAFE, indIndexScale_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_NO_EBP_EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_NO_EBP_EREGI]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET_WIN95_SAFE, indIndexOffset_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_NO_EBP_EREGI, _AddP_eRegP_no_EBP_eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[IMMI]+100;
        DFA_PRODUCTION__SET_VALID(INDOFFSET32_WIN95_SAFE, indOffset32_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[IMMI8]+100;
        DFA_PRODUCTION__SET_VALID(INDOFFSET8_WIN95_SAFE, indOffset8_win95_safe_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_REGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_REGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDOFFSET32, load_long_indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indOffset32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP__LSHIFTI_EREGI_IMMI2) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP__LSHIFTI_EREGI_IMMI2]+_kids[1]->_cost[IMMI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALEOFFSET, indIndexScaleOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexScaleOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxScaleOff_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScaleOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScaleOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI2];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP__LSHIFTI_EREGI_IMMI2, _AddP_eRegP__LShiftI_eRegI_immI2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI2]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXSCALE, indIndexScale_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexScale_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxScale_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxScale_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxScale_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEX, indIndex_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndex_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDP_EREGP_EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ADDP_EREGP_EREGI]+_kids[1]->_cost[IMMI]+10;
        DFA_PRODUCTION__SET_VALID(INDINDEXOFFSET, indIndexOffset_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indIndexOffset_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaPIdxOff_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaPIdxOff_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaPIdxOff_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_ADDP_EREGP_EREGI, _AddP_eRegP_eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMP) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMP]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32X, indOffset32X_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(INDOFFSET32, indOffset32_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indOffset32_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP32_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP32_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP32_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(INDOFFSET8, indOffset8_rule, c)
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indOffset8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+110+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, leaP8_rule, c+110+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(PREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, leaP8_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+110+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+110+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c+110) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c+110) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, leaP8_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+110)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c+110) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+110)
      }
    }
}
void  State::_sub_Op_AndI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_ANDI_EREGI_MEMORY, _AndI_eRegI_memory_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI_EREGI_IMMI, _AndI_eRegI_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _CMPLTMASK_NCXREGI_NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_CMPLTMASK_NCXREGI_NCXREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI_NCXREGI__CMPLTMASK_NCXREGI_NCXREGI, _AndI_ncxRegI__CmpLTMask_ncxRegI_ncxRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CMPLTMASK_NCXREGI_NCXREGI) && STATE__VALID_CHILD(_kids[1], NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[_CMPLTMASK_NCXREGI_NCXREGI]+_kids[1]->_cost[NCXREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__CMPLTMASK_NCXREGI_NCXREGI_NCXREGI, _AndI__CmpLTMask_ncxRegI_ncxRegI_ncxRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ANDI_EREGI__LOADI_MEMORY_, _AndI_eRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__EREGI, _AndI__LoadI_memory__eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, andI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, andI_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI, _AndI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_65535, _AndI__LoadI_memory__immI_65535_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADI_MEMORY__IMMI_255, _AndI__LoadI_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_65535]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2US_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2US_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_255]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2UB_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2UB_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI16) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI16];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI16, _AndI__LoadUS_memory__immI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_255];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUS_MEMORY__IMMI_255, _AndI__LoadUS_memory__immI_255_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_ANDI__LOADUB_MEMORY__IMMI8, _AndI__LoadUB_memory__immI8_rule, c)
    }
}
void  State::_sub_Op_AndL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_32BITS]+250;
        DFA_PRODUCTION__SET_VALID(EREGL, zerox_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, zerox_long_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, zerox_long_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EREGI_]+_kids[1]->_cost[IMML_32BITS]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convI2L_reg_zex_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convI2L_reg_zex_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, andL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, andL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, andL_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[IMML_32BITS];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_NADXREGI__IMML_32BITS, _AndL__ConvI2L_nadxRegI__immL_32bits_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EAXREGI_) && STATE__VALID_CHILD(_kids[1], IMML_32BITS) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EAXREGI_]+_kids[1]->_cost[IMML_32BITS];
        DFA_PRODUCTION__SET_VALID(_ANDL__CONVI2L_EAXREGI__IMML_32BITS, _AndL__ConvI2L_eAXRegI__immL_32bits_rule, c)
    }
}
void  State::_sub_Op_AryEq(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, array_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, array_equals_rule, c)
    }
}
void  State::_sub_Op_AtanD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 10079 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 2176 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, atanD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, atanD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, atanD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 10069 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 2187 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, atanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, atanDPR_reg_rule, c)
    }
}
void  State::_sub_Op_Binary(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LEGT) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_COMMUTE]+_kids[1]->_cost[FLAGSREG_LONG_LEGT];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT, _Binary_cmpOp_commute_flagsReg_long_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_EQNE) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_EQNE];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FLAGSREG_LONG_EQNE, _Binary_cmpOp_flagsReg_long_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_, _Binary_eRegL__LoadL_load_long_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LTGE) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_LTGE];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FLAGSREG_LONG_LTGE, _Binary_cmpOp_flagsReg_long_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NADXREGI) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[NADXREGI]+_kids[1]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_NADXREGI_EAXREGI, _Binary_nadxRegI_eAXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_EAXREGI, _Binary_eSIRegP_eAXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_IMMI, _Binary_eSIRegP_immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[EDXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_EDXREGI, _Binary_eDIRegP_eDXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ESIREGP) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ESIREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_ESIREGP, _Binary_eDIRegP_eSIRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EDXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_ESIREGP_EDXREGI, _Binary_eSIRegP_eDXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EDIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EDIREGP]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EDIREGP_ECXREGI, _Binary_eDIRegP_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGI_ECXREGI, _Binary_eAXRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGP) && STATE__VALID_CHILD(_kids[1], ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[EAXREGP]+_kids[1]->_cost[ECXREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGP_ECXREGP, _Binary_eAXRegP_eCXRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EBCXREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_EADXREGL_EBCXREGL, _Binary_eADXRegL_eBCXRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGI_EREGI, _Binary_eAXRegI_eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EAXREGP]+_kids[1]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EAXREGP_EREGP, _Binary_eAXRegP_eRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGL_EREGL, _Binary_eRegL_eRegL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGD_REGD, _Binary_regD_regD_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGF_REGF, _Binary_regF_regF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGFPR_REGFPR, _Binary_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGDPR_REGDPR, _Binary_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGFPR1_REGFPR, _Binary_regFPR1_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_BINARY_REGDPR1_REGDPR, _Binary_regDPR1_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP_FCMOV) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_FCMOV]+_kids[1]->_cost[EFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_FCMOV_EFLAGSREGU, _Binary_cmpOp_fcmov_eFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGP_EREGP, _Binary_eRegP_eRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGI__LOADI_MEMORY_, _Binary_eRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPUCF_EFLAGSREGUCF, _Binary_cmpOpUCF_eFlagsRegUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOPU_EFLAGSREGU, _Binary_cmpOpU_eFlagsRegU_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_BINARY_EREGI_EREGI, _Binary_eRegI_eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG];
        DFA_PRODUCTION__SET_VALID(_BINARY_CMPOP_EFLAGSREG, _Binary_cmpOp_eFlagsReg_rule, c)
    }
}
void  State::_sub_Op_Bool(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_COMMUTE, cmpOp_commute_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP_FCMOV, cmpOp_fcmov_rule, c)
    }
    if(         
#line 5013 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
n->as_Bool()->_test._test == BoolTest::ne ||
            n->as_Bool()->_test._test == BoolTest::eq
#line 2331 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF2, cmpOpUCF2_rule, c)
    }
    if(         
#line 4994 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
n->as_Bool()->_test._test == BoolTest::lt ||
            n->as_Bool()->_test._test == BoolTest::ge ||
            n->as_Bool()->_test._test == BoolTest::le ||
            n->as_Bool()->_test._test == BoolTest::gt
#line 2342 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPUCF, cmpOpUCF_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOPU, cmpOpU_rule, c)
    }
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(CMPOP, cmpOp_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_int_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_int_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, bytes_reverse_long_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, bytes_reverse_long_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_unsigned_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_unsigned_short_rule, c)
    }
}
void  State::_sub_Op_ReverseBytesS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, bytes_reverse_short_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, bytes_reverse_short_rule, c)
    }
}
void  State::_sub_Op_CallDynamicJava(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallDynamicJavaDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeaf(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafDirect_rule, c)
    }
}
void  State::_sub_Op_CallLeafNoFP(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallLeafNoFPDirect_rule, c)
    }
}
void  State::_sub_Op_CallRuntime(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallRuntimeDirect_rule, c)
    }
}
void  State::_sub_Op_CallStaticJava(const Node *n){
    if(         (
#line 13205 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
((CallStaticJavaNode*)n)->is_method_handle_invoke()
#line 2444 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaHandle_rule, c)
    }
    if(         (
#line 13186 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
! ((CallStaticJavaNode*)n)->is_method_handle_invoke()
#line 2452 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = 300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, CallStaticJavaDirect_rule, c)
      }
    }
}
void  State::_sub_Op_CastII(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(EREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, castII_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, castII_rule, c)
    }
}
void  State::_sub_Op_CastX2P(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(EAXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, castX2P_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castX2P_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castX2P_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_CastP2X(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP];
        DFA_PRODUCTION__SET_VALID(_CASTP2X_EREGP_, _CastP2X_eRegP__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+50;
        DFA_PRODUCTION__SET_VALID(EREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, castP2X_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, castP2X_rule, c)
    }
}
void  State::_sub_Op_CastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, castPP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, castPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, castPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_CheckCastPP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, checkCastPP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, checkCastPP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, checkCastPP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_ClearArray(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ECXREGI) && STATE__VALID_CHILD(_kids[1], EDIREGP) ) {
      unsigned int c = _kids[0]->_cost[ECXREGI]+_kids[1]->_cost[EDIREGP]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, rep_stos_rule, c)
    }
}
void  State::_sub_Op_CMoveD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 13151 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 2581 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, cmovDD_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, cmovDD_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 13141 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 2592 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 13018 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 2604 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, cmovDD_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, cmovDD_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 13008 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 2621 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 12890 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 2641 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, cmovDD_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, cmovDD_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, cmovDD_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 12880 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 2658 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, cmovDDPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cmovDDPR_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 7612 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 2678 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, fcmovD_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, fcmovD_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 7595 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 2695 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, fcmovD_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, fcmovD_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGD_REGD) &&
        (
#line 7550 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 2712 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGD_REGD]+200;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, fcmovD_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, fcmovD_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, fcmovD_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR_REGDPR) &&
        (
#line 7506 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 2729 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGDPR_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, fcmovDPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, fcmovDPR_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FCMOV_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGDPR1_REGDPR) &&
        (
#line 7484 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 2749 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FCMOV_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGDPR1_REGDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, fcmovDPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, fcmovDPR_regU_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 13170 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 2771 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 13160 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt 
#line 2780 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 13036 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 2790 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 13027 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 2801 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 12908 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=1 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 2815 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, cmovFF_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 12899 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 2826 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, cmovFFPR_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, cmovFFPR_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 7585 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 2840 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 7568 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 2851 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGF_REGF) &&
        (
#line 7532 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 2862 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGF_REGF]+200;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, fcmovF_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR_REGFPR) &&
        (
#line 7519 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 2873 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_REGFPR_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, fcmovFPR_regS_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, fcmovFPR_regS_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FCMOV_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_REGFPR1_REGFPR) &&
        (
#line 7495 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 2887 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FCMOV_EFLAGSREGU]+_kids[1]->_cost[_BINARY_REGFPR1_REGFPR]+200;
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, fcmovFPR_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, fcmovFPR_regU_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI__LOADI_MEMORY_) &&
        (
#line 13119 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 2903 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGI__LOADI_MEMORY_]+250;
        DFA_PRODUCTION__SET_VALID(EREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 13109 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 2923 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI__LOADI_MEMORY_) &&
        (
#line 12986 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 2967 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 12976 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 3011 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI__LOADI_MEMORY_) &&
        (
#line 12858 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 3055 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_mem_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 12848 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 3099 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovII_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovII_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI__LOADI_MEMORY_) &&
        (
#line 7401 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3143 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_memUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_memUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI__LOADI_MEMORY_) &&
        (
#line 7391 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3187 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_memU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_memU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI__LOADI_MEMORY_) &&
        (
#line 7380 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3231 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGI__LOADI_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 7370 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3275 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 7360 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3319 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 7350 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3363 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmovI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 7333 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
!VM_Version::supports_cmov() 
#line 3407 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, jmovI_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, jmovI_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGI_EREGI) &&
        (
#line 7316 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
!VM_Version::supports_cmov() 
#line 3451 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGI_EREGI]+200;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, jmovI_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, jmovI_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 13098 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 3497 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 13087 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 3509 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_LEGT_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 12965 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 3529 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 12954 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 3549 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_) &&
        (
#line 12837 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 3569 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGL__LOADL_LOAD_LONG_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_mem_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_mem_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 12826 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 3589 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+400;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovLL_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovLL_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovLL_reg_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 7643 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3609 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_regUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 7632 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3629 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_regU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGL_EREGL) &&
        (
#line 7621 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3649 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGL_EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, cmovL_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, cmovL_reg_rule, c)
      }
    }
}
void  State::_sub_Op_CMoveP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 13130 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt )
#line 3671 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_COMMUTE_FLAGSREG_LONG_LEGT]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_LEGT_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_LEGT_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_LEGT_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_EQNE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 12997 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne )
#line 3698 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_EQNE]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_EQNE_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_EQNE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_EQNE_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_FLAGSREG_LONG_LTGE) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 12869 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && ( _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge )
#line 3763 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_FLAGSREG_LONG_LTGE]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovPP_reg_LTGE_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovPP_reg_LTGE_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovPP_reg_LTGE_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPUCF_EFLAGSREGUCF) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 7447 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3828 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPUCF_EFLAGSREGUCF]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_regUCF_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_regUCF_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regUCF_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOPU_EFLAGSREGU) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 7437 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 3893 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOPU_EFLAGSREGU]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_regU_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_regU_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_regU_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+300;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_reg_nonP6_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_reg_nonP6_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_nonP6_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_CMPOP_EFLAGSREG) && STATE__VALID_CHILD(_kids[1], _BINARY_EREGP_EREGP) &&
        (
#line 7411 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() 
#line 4018 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_CMPOP_EFLAGSREG]+_kids[1]->_cost[_BINARY_EREGP_EREGP]+200;
      if (STATE__NOT_YET_VALID(EREGP) || _cost[EREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTP) || _cost[STACKSLOTP] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ANYREGP) || _cost[ANYREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ANYREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGP) || _cost[EAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGP_NO_EBP) || _cost[EREGP_NO_EBP] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(INDIRECT_WIN95_SAFE) || _cost[INDIRECT_WIN95_SAFE] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, cmovP_reg_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGP) || _cost[EBXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGP) || _cost[NAXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(PREGP) || _cost[PREGP] > c) {
        DFA_PRODUCTION__SET_VALID(PREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGP) || _cost[ECXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NABXREGP) || _cost[NABXREGP] > c) {
        DFA_PRODUCTION__SET_VALID(NABXREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGP) || _cost[ESIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_REGP) || _cost[LOAD_LONG_REGP] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_INDIRECT) || _cost[LOAD_LONG_INDIRECT] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, cmovP_reg_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(LOAD_LONG_MEMORY) || _cost[LOAD_LONG_MEMORY] > c+100) {
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGP) || _cost[EDIREGP] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGP, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(INDIRECT) || _cost[INDIRECT] > c) {
        DFA_PRODUCTION__SET_VALID(INDIRECT, cmovP_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(MEMORY) || _cost[MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
      }
      if (STATE__NOT_YET_VALID(LONG_MEMORY) || _cost[LONG_MEMORY] > c) {
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9583 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4085 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpD_ccmemCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9566 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4094 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+145;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpD_ccmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9554 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4103 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpD_ccCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9537 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4114 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+145;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpD_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9489 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 4125 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+200;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpDPR_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9476 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE <=1
#line 4136 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpDPR_cc_P6CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9458 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE <=1
#line 4147 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpDPR_cc_P6_rule, c)
      }
    }
}
void  State::_sub_Op_CmpD3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9615 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4160 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+275;
        DFA_PRODUCTION__SET_VALID(XREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpD_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpD_regmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9595 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4180 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+255;
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9523 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 4224 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+300;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR0) &&
        (
#line 9509 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 4268 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR0]+280;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpDPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpDPR_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10469 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 4314 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpF_ccmemCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10452 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 4323 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+165;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpF_ccmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10440 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 4332 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpF_ccCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10423 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 4343 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+145;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpF_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10375 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0
#line 4354 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+200;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpFPR_cc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10361 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE == 0
#line 4365 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGUCF) || _cost[EFLAGSREGUCF] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGUCF, cmpFPR_cc_P6CF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10343 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
VM_Version::supports_cmov() && UseSSE == 0
#line 4376 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+150;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, cmpFPR_cc_P6_rule, c)
      }
    }
}
void  State::_sub_Op_CmpF3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10501 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 4389 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+275;
        DFA_PRODUCTION__SET_VALID(XREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpF_regmem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpF_regmem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10481 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 4409 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+255;
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpF_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10409 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0
#line 4453 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+300;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR0) &&
        (
#line 10395 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0
#line 4497 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR0]+280;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpFPR_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpFPR_0_rule, c)
      }
    }
}
void  State::_sub_Op_CmpI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _ANDI_EREGI_MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_EREGI_MEMORY]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI_EREGI_IMMI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_ANDI_EREGI_IMMI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testI_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, compI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, cmpL_reg_flags_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+300;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_LEGT) || _cost[FLAGSREG_LONG_LEGT] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LEGT, cmpL_zero_flags_LEGT_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, cmpL_reg_flags_EQNE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+200;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_EQNE) || _cost[FLAGSREG_LONG_EQNE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_EQNE, cmpL_zero_flags_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, cmpL_reg_flags_LTGE_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML0) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML0]+100;
      if (STATE__NOT_YET_VALID(FLAGSREG_LONG_LTGE) || _cost[FLAGSREG_LONG_LTGE] > c) {
        DFA_PRODUCTION__SET_VALID(FLAGSREG_LONG_LTGE, cmpL_zero_flags_LTGE_rule, c)
      }
    }
}
void  State::_sub_Op_CmpL3(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+1000;
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpL3_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpL3_reg_reg_rule, c)
    }
}
void  State::_sub_Op_CmpLTMask(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[NCXREGI];
        DFA_PRODUCTION__SET_VALID(_CMPLTMASK_NCXREGI_NCXREGI, _CmpLTMask_ncxRegI_ncxRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpLTMask0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpLTMask0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[NCXREGI]+400;
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, cmpLTMask_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, cmpLTMask_rule, c)
      }
    }
}
void  State::_sub_Op_CmpP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _PARTIALSUBTYPECHECK_ESIREGP_EAXREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[_PARTIALSUBTYPECHECK_ESIREGP_EAXREGP]+_kids[1]->_cost[IMMP0]+1000;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, partialSubtypeCheck_vs_Zero_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADP_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[_LOADP_MEMORY_]+_kids[1]->_cost[IMMI0]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testP_Reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMP0) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMP0]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREG) || _cost[EFLAGSREG] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, testP_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) &&
        (
#line 12222 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 !n->in(2)->in(2)->bottom_type()->isa_oop_ptr() 
#line 4704 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_mem_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], _LOADP_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[_LOADP_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], IMMP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[IMMP]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EREGP]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compP_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CmpU(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI0) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, testU_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+500;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EFLAGSREGU) || _cost[EFLAGSREGU] > c) {
        DFA_PRODUCTION__SET_VALID(EFLAGSREGU, compU_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_CompareAndSwapI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapI_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapL_rule, c)
    }
}
void  State::_sub_Op_CompareAndSwapP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], PREGP) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_ECXREGP) ) {
      unsigned int c = _kids[0]->_cost[PREGP]+_kids[1]->_cost[_BINARY_EAXREGP_ECXREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, compareAndSwapP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, compareAndSwapP_rule, c)
    }
}
void  State::_sub_Op_ConD(const Node *n){
    if(         
#line 4085 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && jlong_cast(n->getd()) == 0 
#line 4807 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMD0, immD0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD, loadConD0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(REGD6, loadConD0_rule, c+100)
        DFA_PRODUCTION__SET_VALID(REGD7, loadConD0_rule, c+100)
    }
    if(         
#line 4072 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 4818 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMD, immD_rule, c)
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD, loadConD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD6, loadConD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGD7, loadConD_rule, c+125)
      }
    }
    if(         
#line 4063 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 4835 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR, immDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR_rule, c+125)
    }
    if(         
#line 4053 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && n->getd() == 1.0 
#line 4847 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR1, immDPR1_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR1_rule, c+125)
      }
    }
    if(         
#line 4043 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && n->getd() == 0.0 && !g_isnan(n->getd()) 
#line 4867 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMDPR0, immDPR0_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadConDPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadConDPR0_rule, c+125)
      }
    }
}
void  State::_sub_Op_ConF(const Node *n){
    if(         
#line 4134 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE >= 1 && jint_cast(n->getf()) == 0 
#line 4889 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF0, immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGF, loadConF0_rule, c+100)
    }
    if(         
#line 4124 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE >= 1
#line 4898 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMF, immF_rule, c)
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGF, loadConF_rule, c+125)
      }
    }
    if(         
#line 4114 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE == 0 
#line 4909 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR, immFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR_rule, c+125)
    }
    if(         
#line 4104 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0 && n->getf() == 1.0F
#line 4919 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR1, immFPR1_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR1_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR1_rule, c+125)
      }
    }
    if(         
#line 4094 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE == 0 && n->getf() == 0.0F
#line 4933 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMFPR0, immFPR0_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadConFPR0_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadConFPR0_rule, c+125)
      }
    }
}
void  State::_sub_Op_ConI(const Node *n){
    int _n_get_int__ = n->get_int();
    if(         
#line 4172 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == 65535
#line 4950 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_65535, immI_65535_rule, c)
    }
    if(         
#line 4163 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 255 
#line 4958 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_255, immI_255_rule, c)
    }
    if(         
#line 4154 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 24 
#line 4966 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_24, immI_24_rule, c)
    }
    if(         
#line 4146 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 16 
#line 4974 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_16, immI_16_rule, c)
    }
    if(         
#line 3952 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 3 
#line 4982 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_3, immI_3_rule, c)
    }
    if(         
#line 3943 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 2 
#line 4990 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_2, immI_2_rule, c)
    }
    if(         
#line 3934 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 1 
#line 4998 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1, immI_1_rule, c)
    }
    if(         
#line 3925 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ >= 32 && _n_get_int__ <= 63 
#line 5006 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32_63, immI_32_63_rule, c)
    }
    if(         
#line 3916 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ >= 1 && _n_get_int__ <= 31 
#line 5014 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_1_31, immI_1_31_rule, c)
    }
    if(         
#line 3907 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_int__ == 32 
#line 5022 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_32, immI_32_rule, c)
    }
    if(         
#line 3897 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
(-32768 <= _n_get_int__) && (_n_get_int__ <= 32767)
#line 5030 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI16, immI16_rule, c)
    }
    if(         
#line 3888 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
(-128 <= _n_get_int__) && (_n_get_int__ <= 127)
#line 5038 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 5;
        DFA_PRODUCTION__SET_VALID(IMMI8, immI8_rule, c)
    }
    if(         
#line 3880 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
0 <= _n_get_int__ && (_n_get_int__ <= 3)
#line 5046 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI2, immI2_rule, c)
    }
    if(         
#line 3870 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == -1
#line 5054 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI_M1, immI_M1_rule, c)
    }
    if(         
#line 3860 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == 1
#line 5062 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI1, immI1_rule, c)
    }
    if(         
#line 3850 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_int__ == 0
#line 5070 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMI0, immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+50+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadConI0_rule, c+50)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadConI0_rule, c+50)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMI, immI_rule, c)
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadConI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+100) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadConI_rule, c+100)
      }
    }
   if ( /* EREGI KNOWN_VALID || */ _cost[EREGI] > 100) {
     DFA_PRODUCTION(EREGI, loadConI_rule, 100)
   }
   if ( /* STACKSLOTI KNOWN_VALID || */ _cost[STACKSLOTI] > 100+100) {
     DFA_PRODUCTION(STACKSLOTI, storeSSI_rule, 100+100)
   }
   if ( /* XREGI KNOWN_VALID || */ _cost[XREGI] > 100) {
     DFA_PRODUCTION(XREGI, loadConI_rule, 100)
   }
   if ( /* EAXREGI KNOWN_VALID || */ _cost[EAXREGI] > 100) {
     DFA_PRODUCTION(EAXREGI, loadConI_rule, 100)
   }
   if ( /* NCXREGI KNOWN_VALID || */ _cost[NCXREGI] > 100) {
     DFA_PRODUCTION(NCXREGI, loadConI_rule, 100)
   }
   if ( /* EBXREGI KNOWN_VALID || */ _cost[EBXREGI] > 100) {
     DFA_PRODUCTION(EBXREGI, loadConI_rule, 100)
   }
   if ( /* NADXREGI KNOWN_VALID || */ _cost[NADXREGI] > 100) {
     DFA_PRODUCTION(NADXREGI, loadConI_rule, 100)
   }
   if ( /* ECXREGI KNOWN_VALID || */ _cost[ECXREGI] > 100) {
     DFA_PRODUCTION(ECXREGI, loadConI_rule, 100)
   }
   if ( /* NAXREGI KNOWN_VALID || */ _cost[NAXREGI] > 100) {
     DFA_PRODUCTION(NAXREGI, loadConI_rule, 100)
   }
   if ( /* EDXREGI KNOWN_VALID || */ _cost[EDXREGI] > 100) {
     DFA_PRODUCTION(EDXREGI, loadConI_rule, 100)
   }
   if ( /* EDIREGI KNOWN_VALID || */ _cost[EDIREGI] > 100) {
     DFA_PRODUCTION(EDIREGI, loadConI_rule, 100)
   }
   if ( /* ESIREGI KNOWN_VALID || */ _cost[ESIREGI] > 100) {
     DFA_PRODUCTION(ESIREGI, loadConI_rule, 100)
   }
}
void  State::_sub_Op_ConL(const Node *n){
    jlong _n_get_long__ = n->get_long();
    if(         
#line 4031 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_long__ == (int)(_n_get_long__)
#line 5169 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML32, immL32_rule, c)
        DFA_PRODUCTION__SET_VALID(EADXREGL_LOW_ONLY, loadConL_low_only_rule, c+250)
    }
    if(         
#line 4021 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
_n_get_long__ == 0xFFFFFFFFL
#line 5178 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_32BITS, immL_32bits_rule, c)
    }
    if(         
#line 4011 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
(0 <= _n_get_long__) && (_n_get_long__ <= 127)
#line 5186 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_127, immL_127_rule, c)
    }
    if(         
#line 4000 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_long__ == -1L 
#line 5194 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML_M1, immL_M1_rule, c)
    }
    if(         
#line 3990 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _n_get_long__ == 0L 
#line 5202 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMML0, immL0_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, loadConL0_rule, c+150)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+150+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadConL0_rule, c+150)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadConL0_rule, c+150)
    }
    {
      unsigned int c = 20;
        DFA_PRODUCTION__SET_VALID(IMML, immL_rule, c)
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadConL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadConL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadConL_rule, c+200)
      }
    }
   if ( /* EREGL KNOWN_VALID || */ _cost[EREGL] > 200) {
     DFA_PRODUCTION(EREGL, loadConL_rule, 200)
   }
   if ( /* STACKSLOTL KNOWN_VALID || */ _cost[STACKSLOTL] > 200+200) {
     DFA_PRODUCTION(STACKSLOTL, storeSSL_rule, 200+200)
   }
   if ( /* EADXREGL KNOWN_VALID || */ _cost[EADXREGL] > 200) {
     DFA_PRODUCTION(EADXREGL, loadConL_rule, 200)
   }
   if ( /* EBCXREGL KNOWN_VALID || */ _cost[EBCXREGL] > 200) {
     DFA_PRODUCTION(EBCXREGL, loadConL_rule, 200)
   }
}
void  State::_sub_Op_ConP(const Node *n){
    if(         
#line 3971 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 n->get_ptr() == 0 
#line 5244 "../generated/adfiles/dfa_x86_32.cpp"
 ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(IMMP0, immP0_rule, c)
    }
    {
      unsigned int c = 10;
        DFA_PRODUCTION__SET_VALID(IMMP, immP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadConP_rule, c+100+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(PREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadConP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadConP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(DIRECT, direct_rule, c)
        DFA_PRODUCTION(MEMORY, direct_rule, c)	  // overwrites higher cost rule
        DFA_PRODUCTION(LONG_MEMORY, direct_rule, c)	  // overwrites higher cost rule
    }
     DFA_PRODUCTION(EREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(STACKSLOTP, storeSSP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ANYREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EAXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EREGP_NO_EBP, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(INDIRECT_WIN95_SAFE, loadConP_rule, 100+100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EBXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NAXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(PREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ECXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(NABXREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(ESIREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_REGP, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_INDIRECT, loadConP_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(LOAD_LONG_MEMORY, load_long_indirect_rule, 100+100)	  // overwrites higher cost rule
     DFA_PRODUCTION(EDIREGP, loadConP_rule, 100)	  // overwrites higher cost rule
     DFA_PRODUCTION(INDIRECT, loadConP_rule, 100)	  // overwrites higher cost rule
}
void  State::_sub_Op_Conv2B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convP2B_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convP2B_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convI2B_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_IMMF__) &&
        (
#line 810 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=1
#line 5354 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_IMMF__]+150;
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D__LOADF_MEMORY___) &&
        (
#line 798 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=1
#line 5363 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D__LOADF_MEMORY___]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SQRTD__CONVF2D_REGF__) &&
        (
#line 786 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=1
#line 5374 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SQRTD__CONVF2D_REGF__]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, sqrtF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11008 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5385 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convD2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10985 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==1
#line 5396 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convDPR2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10975 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 5407 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convDPR2FPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1];
        DFA_PRODUCTION__SET_VALID(_CONVD2F_REGDPR1_, _ConvD2F_regDPR1__rule, c)
    }
}
void  State::_sub_Op_ConvD2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11085 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5424 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convD2I_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convD2I_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 11065 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 5444 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convDPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convDPR2I_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11136 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5490 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, convD2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convD2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 11113 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 5502 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convDPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convDPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convDPR2L_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF) ) {
      unsigned int c = _kids[0]->_cost[IMMF];
        DFA_PRODUCTION__SET_VALID(_CONVF2D_IMMF_, _ConvF2D_immF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_CONVF2D__LOADF_MEMORY__, _ConvF2D__LoadF_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) ) {
      unsigned int c = _kids[0]->_cost[REGF];
        DFA_PRODUCTION__SET_VALID(_CONVF2D_REGF_, _ConvF2D_regF__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11054 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 5536 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convF2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, convF2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, convF2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11035 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==1
#line 5547 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, convF2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convF2DPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11026 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==1
#line 5559 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, convFPR2D_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11018 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 5580 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, convFPR2DPR_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convFPR2DPR_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11215 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5602 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convF2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convF2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11194 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 5622 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, convFPR2I_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, convFPR2I_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvF2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11267 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 5668 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
        DFA_PRODUCTION__SET_VALID(EADXREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, convF2L_reg_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convF2L_reg_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11243 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 5680 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, convFPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, convFPR2L_reg_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convFPR2L_reg_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2D(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11363 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && !Compile__current____select_24_bit_instr__
#line 5703 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, convI2DPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convI2DPR_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11350 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && UseXmmI2D 
#line 5715 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convXI2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, convXI2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, convXI2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11339 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 
#line 5726 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, convI2D_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, convI2D_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11329 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && !UseXmmI2D 
#line 5743 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, convI2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, convI2D_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, convI2D_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11319 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 5760 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, convI2DPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, convI2DPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2F(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11448 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE>=2 && UseXmmI2F 
#line 5783 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convXI2F_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11437 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==1 || UseSSE>=2 && !UseXmmI2F 
#line 5792 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, convI2F_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11425 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 5803 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, convI2FPR_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, convI2FPR_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11413 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 5813 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, convI2FPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, convI2FPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 11400 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 5827 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+200;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convI2FPR_SSF_mem_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11387 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 5842 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convI2FPR_SSF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11375 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && n->in(1)->Opcode() == Op_AndI && n->in(1)->in(2)->is_Con() && n->in(1)->in(2)->get_int() == 255 
#line 5859 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, conv24I2FPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, conv24I2FPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_ConvI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_EREGI_, _ConvI2L_eRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+375;
        DFA_PRODUCTION__SET_VALID(EREGL, convI2L_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, convI2L_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, convI2L_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_EAXREGI_, _ConvI2L_eAXRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NADXREGI) ) {
      unsigned int c = _kids[0]->_cost[NADXREGI];
        DFA_PRODUCTION__SET_VALID(_CONVI2L_NADXREGI_, _ConvI2L_nadxRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_65535) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_65535]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_65535_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_65535_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADI_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADI_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI16) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI16]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_immI16_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_immI16_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_immI16_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUS_MEMORY__IMMI_255) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUS_MEMORY__IMMI_255]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_immI_255_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_immI_255_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadS2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadS2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDI__LOADUB_MEMORY__IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_ANDI__LOADUB_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUB2L_immI8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUB2L_immI8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUB2L_immI8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADUB_MEMORY_]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUB2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADB_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_LOADB_MEMORY_]+375;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadB2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadB2L_rule, c)
      }
    }
}
void  State::_sub_Op_ConvL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11510 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6061 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGD, convL2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, convL2D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, convL2D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11496 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 6072 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, convL2DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
    }
}
void  State::_sub_Op_ConvL2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, convL2FPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11525 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 6093 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(REGF, convL2F_reg_rule, c)
    }
}
void  State::_sub_Op_ConvL2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, convL2I_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, convL2I_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63) &&
        (
#line 8090 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 6121 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63]+1*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_RShift_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_RShift_high_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63) &&
        (
#line 8090 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 6167 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63]+1*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_RShift_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_RShift_high_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32) &&
        (
#line 8075 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 6213 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32]+0*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_high_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_high_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32) &&
        (
#line 8075 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_kids[0]->_kids[1]->_leaf->Opcode() == Op_ConL &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() >= min_jint &&
             _kids[0]->_kids[0]->_kids[1]->_leaf->as_Type()->type()->is_long()->get_con() <= max_jint 
#line 6259 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32]+0*100 + 1*400 - 150;
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_imm_high_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_imm_high_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL];
        DFA_PRODUCTION__SET_VALID(_CONVL2I_EREGL_, _ConvL2I_eRegL__rule, c)
    }
}
void  State::_sub_Op_CosD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10037 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6309 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+1800;
        DFA_PRODUCTION__SET_VALID(REGD, cosD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, cosD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, cosD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 10027 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 6320 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+1800;
        DFA_PRODUCTION__SET_VALID(REGDPR1, cosDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, cosDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, cosDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, cosDPR_reg_rule, c)
    }
}
void  State::_sub_Op_CountedLoopEnd(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+200;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndUCF_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEndU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpLoopEnd_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 5631 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseCountLeadingZerosInstruction
#line 6352 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosI_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosI_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 5619 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseCountLeadingZerosInstruction
#line 6372 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosI_rule, c)
      }
    }
}
void  State::_sub_Op_CountLeadingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5679 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
!UseCountLeadingZerosInstruction
#line 6418 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosL_bsr_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosL_bsr_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5656 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseCountLeadingZerosInstruction
#line 6438 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, countLeadingZerosL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, countLeadingZerosL_rule, c)
      }
    }
}
void  State::_sub_Op_CountTrailingZerosI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosI_rule, c)
    }
}
void  State::_sub_Op_CountTrailingZerosL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, countTrailingZerosL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, countTrailingZerosL_rule, c)
    }
}
void  State::_sub_Op_CreateEx(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EAXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, CreateException_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(NAXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, CreateException_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, CreateException_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_DivD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 678 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 6542 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, vdivD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, vdivD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, vdivD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 666 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 6553 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vdivD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vdivD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vdivD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 654 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 6570 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vdivD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vdivD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vdivD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 643 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 6587 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, divD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, divD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 631 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 6604 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, divD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, divD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 619 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 6621 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, divD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, divD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, divD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_DIVD_REGDPR_REGDPR, _DivD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGNOTDPR1) &&
        (
#line 9935 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && Compile::current()->has_method() && Compile::current()->method()->is_strict() 
#line 6642 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGNOTDPR1]+01;
        DFA_PRODUCTION__SET_VALID(REGDPR1, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, strictfp_divDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, strictfp_divDPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9912 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 6654 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, divDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, divDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 607 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 6677 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, vdivF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 595 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 6686 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vdivF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 583 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 6697 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vdivF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 572 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 6708 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 560 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 6719 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 548 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 6730 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, divF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10888 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 6741 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, divFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, divFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10875 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 6751 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, divFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBF_REGFPR_REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10859 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 6766 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBF_REGFPR_REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, subFPR_divFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, subFPR_divFPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_DivI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, divI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, divI_eReg_rule, c)
    }
}
void  State::_sub_Op_DivL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML32]+1000;
        DFA_PRODUCTION__SET_VALID(EADXREGL, divL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, divL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, divL_eReg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+10000;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, divL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, divL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, divL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_DivModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+30*100+10*100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, divModI_eReg_divmod_rule, c)
    }
}
void  State::_sub_Op_ExpD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10215 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 6829 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, expD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, expD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, expD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 10179 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 6840 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, expDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, expDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, expDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, expDPR_reg_rule, c)
    }
}
void  State::_sub_Op_FastLock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EBXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EBXREGP]+300;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastLock_rule, c)
    }
}
void  State::_sub_Op_FastUnlock(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP]+_kids[1]->_cost[EAXREGP]+300;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, cmpFastUnlock_rule, c)
    }
}
void  State::_sub_Op_Goto(const Node *n){
    {
      unsigned int c = 300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpDir_rule, c)
    }
}
void  State::_sub_Op_Halt(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, ShouldNotReachHere_rule, c)
    }
}
void  State::_sub_Op_If(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], CMPOP_COMMUTE) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LEGT) &&
        (
#line 13077 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::gt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::le 
#line 6878 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP_COMMUTE]+_kids[1]->_cost[FLAGSREG_LONG_LEGT]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_LEGT_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_EQNE) &&
        (
#line 12945 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::eq || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ne 
#line 6887 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_EQNE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_EQNE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], FLAGSREG_LONG_LTGE) &&
        (
#line 12817 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::lt || _kids[0]->_leaf->as_Bool()->_test._test == BoolTest::ge 
#line 6898 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[FLAGSREG_LONG_LTGE]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, cmpL_LTGE_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF2) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF2]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPUCF) && STATE__VALID_CHILD(_kids[1], EFLAGSREGUCF) ) {
      unsigned int c = _kids[0]->_cost[CMPOPUCF]+_kids[1]->_cost[EFLAGSREGUCF]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConUCF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOPU) && STATE__VALID_CHILD(_kids[1], EFLAGSREGU) ) {
      unsigned int c = _kids[0]->_cost[CMPOPU]+_kids[1]->_cost[EFLAGSREGU]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpConU_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], CMPOP) && STATE__VALID_CHILD(_kids[1], EFLAGSREG) ) {
      unsigned int c = _kids[0]->_cost[CMPOP]+_kids[1]->_cost[EFLAGSREG]+300;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jmpCon_rule, c)
      }
    }
}
void  State::_sub_Op_Jump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+350;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, jumpXtnd_rule, c)
    }
}
void  State::_sub_Op_LShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI_32_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI, _LShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI0_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI, _LShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_EREGI_IMMI_M1, _LShiftI_eRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_NCXREGI_ECXREGI, _LShiftI_ncxRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_EREGI_IMMI8, _LShiftI_eRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_EREGI_IMMI1, _LShiftI_eRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], XREGI) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[XREGI]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_XREGI_IMMI_16, _LShiftI_xRegI_immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], XREGI) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[XREGI]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_XREGI_IMMI_24, _LShiftI_xRegI_immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, salI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, salI_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, salI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, salI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shlI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shlI_eReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_16) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_16];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_16, _LShiftI__LoadI_memory__immI_16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADI_MEMORY__IMMI_24, _LShiftI__LoadI_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADUS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADUS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADUS_MEMORY__IMMI_24, _LShiftI__LoadUS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADS_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI_24) ) {
      unsigned int c = _kids[0]->_cost[_LOADS_MEMORY_]+_kids[1]->_cost[IMMI_24];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI__LOADS_MEMORY__IMMI_24, _LShiftI__LoadS_memory__immI_24_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI2) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI2];
        DFA_PRODUCTION__SET_VALID(_LSHIFTI_EREGI_IMMI2, _LShiftI_eRegI_immI2_rule, c)
    }
}
void  State::_sub_Op_LShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+500+200;
        DFA_PRODUCTION__SET_VALID(EREGL, salL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, salL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, salL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_1_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_3) &&
        (
#line 9306 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseNewLongLShift
#line 7125 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_3]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_3_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_3_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_3_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_2) &&
        (
#line 9287 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseNewLongLShift
#line 7145 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_2]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_2_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_2_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1) &&
        (
#line 9272 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseNewLongLShift
#line 7165 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shlL_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shlL_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shlL_eReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_LoadB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADB_MEMORY_, _LoadB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(XREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadB_rule, c)
    }
}
void  State::_sub_Op_LoadUB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUB_MEMORY_, _LoadUB_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(XREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUB_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUB_rule, c)
    }
}
void  State::_sub_Op_LoadUS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADUS_MEMORY_, _LoadUS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUS_rule, c)
    }
}
void  State::_sub_Op_LoadD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADD_MEMORY_, _LoadD_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6302 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && !UseXmmLoadAndClearUpper
#line 7254 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGD, loadD_partial_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, loadD_partial_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, loadD_partial_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6291 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && UseXmmLoadAndClearUpper
#line 7265 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, loadD_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, loadD_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, loadD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6277 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7282 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGDPR, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadDPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadDPR_rule, c)
    }
}
void  State::_sub_Op_LoadF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADF_MEMORY_, _LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6327 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 7300 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+150;
        DFA_PRODUCTION__SET_VALID(REGFPR, loadFPR_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6315 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 7310 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGF, loadF_rule, c)
    }
}
void  State::_sub_Op_LoadI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADI_MEMORY_, _LoadI_memory__rule, c)
    }
}
void  State::_sub_Op_LoadUI2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+250;
        DFA_PRODUCTION__SET_VALID(EREGL, loadUI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadUI2L_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadUI2L_rule, c)
    }
}
void  State::_sub_Op_LoadKlass(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadKlass_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadKlass_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadKlass_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_MEMORY) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_LOAD_LONG_MEMORY_, _LoadL_load_long_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6224 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((LoadLNode*)n)->require_atomic_access()
#line 7379 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+160;
        DFA_PRODUCTION__SET_VALID(EREGL, loadLX_reg_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadLX_reg_volatile_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadLX_reg_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6210 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((LoadLNode*)n)->require_atomic_access()
#line 7391 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+180;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadLX_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6199 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && ((LoadLNode*)n)->require_atomic_access()
#line 7411 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadL_volatile_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LOAD_LONG_MEMORY) &&
        (
#line 6178 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
!((LoadLNode*)n)->require_atomic_access()
#line 7431 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[LOAD_LONG_MEMORY]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADL_MEMORY_, _LoadL_memory__rule, c)
    }
}
void  State::_sub_Op_LoadPLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadPLocked_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadPLocked_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadPLocked_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadLLocked(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 7861 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7481 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+160;
        DFA_PRODUCTION__SET_VALID(EREGL, loadLX_reg_Locked_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadLX_reg_Locked_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadLX_reg_Locked_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 7847 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7493 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+180;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadLX_Locked_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 7836 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7513 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, loadLLocked_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
}
void  State::_sub_Op_LoadP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADP_MEMORY_, _LoadP_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, loadP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, loadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, loadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_LoadRange(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadRange_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadRange_rule, c)
    }
}
void  State::_sub_Op_LoadS(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
        DFA_PRODUCTION__SET_VALID(_LOADS_MEMORY_, _LoadS_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadS_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadS_rule, c)
    }
}
void  State::_sub_Op_LogD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10309 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7601 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, logD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, logD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, logD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 10291 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7612 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, logDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, logDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, logDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, logDPR_reg_rule, c)
    }
}
void  State::_sub_Op_Log10D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10274 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7626 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, log10D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, log10D_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, log10D_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 10256 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7637 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, log10DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, log10DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, log10DPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, log10DPR_reg_rule, c)
    }
}
void  State::_sub_Op_LoopLimit(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_NADXREGI_EAXREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_NADXREGI_EAXREGI]+_kids[1]->_cost[IMMI]+300;
        DFA_PRODUCTION__SET_VALID(EAXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, loopLimit_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, loopLimit_eReg_rule, c)
    }
}
void  State::_sub_Op_MaxI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+300;
        DFA_PRODUCTION__SET_VALID(EREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, maxI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, maxI_eReg_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquire(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_rule, c)
    }
}
void  State::_sub_Op_MemBarAcquireLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_acquire_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarRelease(const Node *n){
    {
      unsigned int c = 400;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_rule, c)
    }
}
void  State::_sub_Op_MemBarReleaseLock(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_release_lock_rule, c)
    }
}
void  State::_sub_Op_MemBarVolatile(const Node *n){
    if(         (
#line 7277 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
Matcher::post_store_load_barrier(n)
#line 7708 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, unnecessary_membar_volatile_rule, c)
    }
    {
      unsigned int c = 400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_volatile_rule, c)
      }
    }
}
void  State::_sub_Op_MemBarStoreStore(const Node *n){
    {
      unsigned int c = 0;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, membar_storestore_rule, c)
    }
}
void  State::_sub_Op_MinI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+300;
        DFA_PRODUCTION__SET_VALID(EREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, minI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, minI_eReg_rule, c)
    }
}
void  State::_sub_Op_ModD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 9981 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7748 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+250;
        DFA_PRODUCTION__SET_VALID(REGD, modD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, modD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, modD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9967 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 7759 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, modDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, modDPR_reg_rule, c)
    }
}
void  State::_sub_Op_ModF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 10928 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 7774 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+250;
        DFA_PRODUCTION__SET_VALID(REGF, modF_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10915 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 7783 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, modFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, modFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10901 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE==0 && Compile__current____select_24_bit_instr__
#line 7793 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, modFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_ModI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EAXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EAXREGI]+_kids[1]->_cost[ECXREGI]+300;
        DFA_PRODUCTION__SET_VALID(EDXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, modI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, modI_eReg_rule, c)
    }
}
void  State::_sub_Op_ModL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML32) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML32]+1000;
        DFA_PRODUCTION__SET_VALID(EADXREGL, modL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, modL_eReg_imm32_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, modL_eReg_imm32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+10000;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, modL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, modL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, modL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveI2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11649 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7851 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+85;
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11636 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 7860 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+95;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, MoveI2F_stack_reg_sse_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTI) &&
        (
#line 11622 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 7871 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTI]+125;
        DFA_PRODUCTION__SET_VALID(REGFPR, MoveI2FPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, MoveI2FPR_stack_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, MoveI2F_reg_stack_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_MoveF2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11597 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 7893 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+85;
        DFA_PRODUCTION__SET_VALID(EREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, MoveF2I_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, MoveF2I_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11584 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 7913 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveF2I_reg_stack_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 11573 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 7957 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+125;
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, MoveFPR2I_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadSSI_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c+125) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadSSI_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTF) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTF]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, MoveF2I_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, MoveF2I_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MoveL2D(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 11767 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8042 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+85;
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, MoveL2D_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, MoveL2D_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11754 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && !UseXmmLoadAndClearUpper
#line 8053 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+95;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_sse_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, MoveL2D_stack_reg_sse_partial_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, MoveL2D_stack_reg_sse_partial_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11741 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && UseXmmLoadAndClearUpper
#line 8070 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+95;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, MoveL2D_stack_reg_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, MoveL2D_stack_reg_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, MoveL2D_stack_reg_sse_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTL) &&
        (
#line 11726 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8087 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTL]+125;
        DFA_PRODUCTION__SET_VALID(REGDPR, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, MoveL2DPR_stack_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, MoveL2DPR_stack_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+200;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, MoveL2D_reg_stack_rule, c)
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
}
void  State::_sub_Op_MoveD2L(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11697 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8117 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+85;
        DFA_PRODUCTION__SET_VALID(EREGL, MoveD2L_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, MoveD2L_reg_reg_sse_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, MoveD2L_reg_reg_sse_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11685 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 8129 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveD2L_reg_stack_sse_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 11674 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8149 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+125;
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, MoveDPR2L_reg_stack_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, loadSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c+200) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, loadSSL_rule, c+200)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], STACKSLOTD) ) {
      unsigned int c = _kids[0]->_cost[STACKSLOTD]+250;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, MoveD2L_stack_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, MoveD2L_stack_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 536 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8186 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, vmulD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, vmulD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, vmulD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 524 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8197 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vmulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vmulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vmulD_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 524 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8214 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vmulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vmulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vmulD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 512 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8231 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vmulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vmulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vmulD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 501 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8248 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, mulD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, mulD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 489 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8265 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, mulD_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, mulD_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 489 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8282 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, mulD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, mulD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 477 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8299 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, mulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, mulD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, mulD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_MULD_REGDPR_REGDPR, _MulD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9849 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 8320 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+_kids[1]->_cost[REGDPR]+200;
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9849 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 8332 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], IMMDPR) &&
        (
#line 9835 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && _kids[1]->_leaf->getd() != 0.0 && _kids[1]->_leaf->getd() != 1.0 
#line 8352 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[IMMDPR]+200;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) && STATE__VALID_CHILD(_kids[1], REGNOTDPR1) &&
        (
#line 9816 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && Compile::current()->has_method() && Compile::current()->method()->is_strict() 
#line 8372 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+_kids[1]->_cost[REGNOTDPR1]+1;
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, strictfp_mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, strictfp_mulDPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9796 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 8392 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, mulDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, mulDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_MulF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 465 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8415 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, vmulF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 453 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8424 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vmulF_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 453 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8435 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vmulF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 441 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8446 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vmulF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 430 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8457 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 418 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8468 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 418 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8479 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 406 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 8490 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, mulF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_MULF_REGFPR_REGFPR, _MulF_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_MULF_REGFPR__LOADF_MEMORY_, _MulF_regFPR__LoadF_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_MULF__LOADF_MEMORY__REGFPR, _MulF__LoadF_memory__regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10786 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8513 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], IMMFPR) &&
        (
#line 10770 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8523 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[IMMFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_imm_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], MEMORY) &&
        (
#line 10756 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8538 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_mem_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10743 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8555 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10743 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8569 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADF_MEMORY_) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10727 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8583 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADF_MEMORY_]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 10727 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8600 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[_LOADF_MEMORY_]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10710 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 8617 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR, mulFPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, mulFPR_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10695 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 8631 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTF) || _cost[STACKSLOTF] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, mulFPR24_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_MulI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI]+350;
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+350;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_mem_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+300;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+300;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, mulI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, mulI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_MulL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], IMML_127) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[IMML_127]+2*100+2*400;
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_con_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_con_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_con_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8214 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
is_operand_hi32_zero(n->in(1)) && is_operand_hi32_zero(n->in(2))
#line 8830 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+1*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_hi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_hi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_hi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8193 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
is_operand_hi32_zero(n->in(2))
#line 8850 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+2*100+2*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_rhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_rhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_rhi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 8172 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
is_operand_hi32_zero(n->in(1))
#line 8870 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+2*100+2*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_lhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_lhi0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_lhi0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL]+_kids[1]->_cost[EREGL]+4*100+3*400;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulL_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_NADXREGI__IMML_32BITS) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_EAXREGI__IMML_32BITS) &&
        /*mask*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_NADXREGI__IMML_32BITS]+_kids[1]->_cost[_ANDL__CONVI2L_EAXREGI__IMML_32BITS]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulIS_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulIS_eReg_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulIS_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ANDL__CONVI2L_EAXREGI__IMML_32BITS) && STATE__VALID_CHILD(_kids[1], _ANDL__CONVI2L_NADXREGI__IMML_32BITS) &&
        /*mask*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_ANDL__CONVI2L_EAXREGI__IMML_32BITS]+_kids[1]->_cost[_ANDL__CONVI2L_NADXREGI__IMML_32BITS]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulIS_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulIS_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulIS_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_EAXREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[_CONVI2L_EAXREGI_]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulI2L_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulI2L_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_EAXREGI_) && STATE__VALID_CHILD(_kids[1], _CONVI2L_NADXREGI_) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_EAXREGI_]+_kids[1]->_cost[_CONVI2L_NADXREGI_]+300;
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, mulI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, mulI2L_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, mulI2L_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], _CONVI2L_NADXREGI_) ) {
      unsigned int c = _kids[0]->_cost[EADXREGL_LOW_ONLY]+_kids[1]->_cost[_CONVI2L_NADXREGI_];
        DFA_PRODUCTION__SET_VALID(_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_, _MulL_eADXRegL_low_only__ConvI2L_nadxRegI__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], EADXREGL_LOW_ONLY) ) {
      unsigned int c = _kids[0]->_cost[_CONVI2L_NADXREGI_]+_kids[1]->_cost[EADXREGL_LOW_ONLY];
        DFA_PRODUCTION__SET_VALID(_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY, _MulL__ConvI2L_nadxRegI__eADXRegL_low_only_rule, c)
    }
}
void  State::_sub_Op_NegD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 773 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 8977 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, vnegD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, vnegD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, vnegD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 761 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 8988 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, negD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, negD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, negD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 9686 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 9005 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, negDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, negDPR_reg_rule, c)
    }
}
void  State::_sub_Op_NegF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 749 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 9019 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, vnegF_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 738 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 9028 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, negF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) &&
        (
#line 10581 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 9039 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR1, negFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, negFPR_reg_rule, c)
    }
}
void  State::_sub_Op_OrI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C32_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_EREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_EREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_EREGI_IMMI_M1]+_kids[1]->_cost[_URSHIFTI_EREGI_IMMI1]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, rorI_eReg_i1_0_rule, c)
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_i1_0_rule, c)
      }
        DFA_PRODUCTION__SET_VALID(EBXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, rorI_eReg_i1_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, rorI_eReg_i1_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_EREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_EREGI_IMMI1]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rorI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rorI_eReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C32_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C32_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_NCXREGI_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_kids[1]->_leaf == _kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+_kids[1]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C0_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_NCXREGI_ECXREGI) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) && /*shift*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_kids[1]->_kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_NCXREGI_ECXREGI]+_kids[1]->_cost[_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI]+100;
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_Var_C0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_EREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI8) &&
        (
#line 8801 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
  0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 9163 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_EREGI_IMMI8]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i8_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i8_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_EREGI_IMMI8) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_EREGI_IMMI8) &&
        (
#line 8801 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
  0 == ((n->in(1)->in(2)->get_int() + n->in(2)->in(2)->get_int()) & 0x1f)
#line 9207 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_EREGI_IMMI8]+_kids[1]->_cost[_URSHIFTI_EREGI_IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i8_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i8_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _URSHIFTI_EREGI_IMMI_M1) && STATE__VALID_CHILD(_kids[1], _LSHIFTI_EREGI_IMMI1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_URSHIFTI_EREGI_IMMI_M1]+_kids[1]->_cost[_LSHIFTI_EREGI_IMMI1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i1_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i1_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_EREGI_IMMI1) && STATE__VALID_CHILD(_kids[1], _URSHIFTI_EREGI_IMMI_M1) &&
        /*dst*/(_kids[0]->_kids[0]->_leaf == _kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_EREGI_IMMI1]+_kids[1]->_cost[_URSHIFTI_EREGI_IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, rolI_eReg_i1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, rolI_eReg_i1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__IMMI, _OrI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ORI_EREGI__LOADI_MEMORY_, _OrI_eRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_ORI__LOADI_MEMORY__EREGI, _OrI__LoadI_memory__eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_mem_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_mem_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CASTP2X_EREGP_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_CASTP2X_EREGP_]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_castP2X_0_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_castP2X_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _CASTP2X_EREGP_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_CASTP2X_EREGP_]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_castP2X_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_castP2X_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, orI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, orI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_OrL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, orl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, orl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, orl_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_PartialSubtypeCheck(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGP];
        DFA_PRODUCTION__SET_VALID(_PARTIALSUBTYPECHECK_ESIREGP_EAXREGP, _PartialSubtypeCheck_eSIRegP_eAXRegP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], ESIREGP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[ESIREGP]+_kids[1]->_cost[EAXREGP]+1100;
        DFA_PRODUCTION__SET_VALID(EDIREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ANYREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EAXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, partialSubtypeCheck_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, partialSubtypeCheck_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT, partialSubtypeCheck_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_PopCountI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) &&
        (
#line 5778 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 9661 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountI_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountI_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 5766 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 9681 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountI_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountI_rule, c)
      }
    }
}
void  State::_sub_Op_PopCountL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_MEMORY_) &&
        (
#line 5808 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 9727 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_MEMORY_]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountL_mem_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountL_mem_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) &&
        (
#line 5791 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UsePopCountInstruction
#line 9747 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, popCountL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, popCountL_rule, c)
      }
    }
}
void  State::_sub_Op_PowD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 10136 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 9793 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, powD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, powD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, powD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR1) &&
        (
#line 10100 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 9804 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, powDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, powDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, powDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, powDPR_reg_rule, c)
    }
}
void  State::_sub_Op_PrefetchAllocation(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6830 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==2
#line 9818 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6818 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==1
#line 9827 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6806 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && AllocatePrefetchInstr==0
#line 9838 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAllocNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6794 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
AllocatePrefetchInstr==3
#line 9849 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6784 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && AllocatePrefetchInstr!=3
#line 9860 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchAlloc0_rule, c)
      }
    }
}
void  State::_sub_Op_PrefetchRead(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6736 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && ReadPrefetchInstr==2
#line 9873 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchrT2_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6724 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && ReadPrefetchInstr==1
#line 9882 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchrT0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6712 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1 && ReadPrefetchInstr==0
#line 9893 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchrNTA_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6700 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && VM_Version::supports_3dnow_prefetch() || ReadPrefetchInstr==3
#line 9904 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchr_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6690 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !VM_Version::supports_3dnow_prefetch()
#line 9915 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchr0_rule, c)
      }
    }
}
void  State::_sub_Op_PrefetchWrite(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6770 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 9928 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchwNTA_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6758 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && VM_Version::supports_3dnow_prefetch()
#line 9937 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchw_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6748 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !VM_Version::supports_3dnow_prefetch()
#line 9948 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY];
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, prefetchw0_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_XREGI_IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_XREGI_IMMI_16]+_kids[1]->_cost[IMMI_16]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, i2s_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, i2s_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI_XREGI_IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI_XREGI_IMMI_24]+_kids[1]->_cost[IMMI_24]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, i2b_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, i2b_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[ECXREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_CL_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_CL_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI8, _RShiftI__LoadI_memory__immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_RSHIFTI__LOADI_MEMORY__IMMI1, _RShiftI__LoadI_memory__immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, sarI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, sarI_eReg_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_16) && STATE__VALID_CHILD(_kids[1], IMMI_16) &&
        /*sixteen*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_16]+_kids[1]->_cost[IMMI_16]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2S_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2S_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADI_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADI_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadI2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadI2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADUS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADUS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadUS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadUS2B_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _LSHIFTI__LOADS_MEMORY__IMMI_24) && STATE__VALID_CHILD(_kids[1], IMMI_24) &&
        /*twentyfour*/(_kids[0]->_kids[1]->_leaf == _kids[1]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[_LSHIFTI__LOADS_MEMORY__IMMI_24]+_kids[1]->_cost[IMMI_24]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, loadS2B_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, loadS2B_rule, c)
      }
    }
}
void  State::_sub_Op_RShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+600;
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, sarL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, sarL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, sarL_eReg_1_31_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32_63, _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY]+_kids[1]->_cost[IMMI_32_63];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32_63, _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_63_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI_]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL_EADXREGL_LOW_ONLY__CONVI2L_NADXREGI__IMMI_32, _RShiftL__MulL_eADXRegL_low_only__ConvI2L_nadxRegI__immI_32_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY) && STATE__VALID_CHILD(_kids[1], IMMI_32) ) {
      unsigned int c = _kids[0]->_cost[_MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY]+_kids[1]->_cost[IMMI_32];
        DFA_PRODUCTION__SET_VALID(_RSHIFTL__MULL__CONVI2L_NADXREGI__EADXREGL_LOW_ONLY_IMMI_32, _RShiftL__MulL__ConvI2L_nadxRegI__eADXRegL_low_only_immI_32_rule, c)
    }
}
void  State::_sub_Op_Rethrow(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, RethrowException_rule, c)
    }
}
void  State::_sub_Op_Return(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, Ret_rule, c)
    }
}
void  State::_sub_Op_RoundDouble(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10965 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10371 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+125;
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, roundDouble_mem_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], _DIVD_REGDPR_REGDPR) &&
        (
#line 9953 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 && !(Compile::current()->has_method() && Compile::current()->method()->is_strict()) 
#line 10384 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_DIVD_REGDPR_REGDPR]+100;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, divDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR_IMMDPR) &&
        (
#line 9781 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && _kids[0]->_kids[1]->_leaf->getd() != 0.0 && _kids[0]->_kids[1]->_leaf->getd() != 1.0 
#line 10407 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR_IMMDPR]+200;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, addDPR_reg_imm_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR__LOADD_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR__LOADD_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__, _RoundDouble__AddD_regDPR__LoadD_memory___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD__LOADD_MEMORY__REGDPR) ) {
      unsigned int c = _kids[0]->_cost[_ADDD__LOADD_MEMORY__REGDPR];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_, _RoundDouble__AddD__LoadD_memory__regDPR__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _ADDD_REGDPR_REGDPR) &&
        (
#line 9710 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10438 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_ADDD_REGDPR_REGDPR]+250;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, addDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _SUBD_REGDPR_REGDPR) &&
        (
#line 9648 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE <=1
#line 10461 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_SUBD_REGDPR_REGDPR]+250;
      if (STATE__NOT_YET_VALID(STACKSLOTD) || _cost[STACKSLOTD] > c) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTD, subDPR_reg_round_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, loadSSD_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, loadSSD_rule, c+125)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1];
        DFA_PRODUCTION__SET_VALID(_ROUNDDOUBLE_REGDPR1_, _RoundDouble_regDPR1__rule, c)
    }
}
void  State::_sub_Op_RoundFloat(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGFPR) &&
        (
#line 10956 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 10490 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+125;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, roundFloat_mem_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR1) ) {
      unsigned int c = _kids[0]->_cost[REGFPR1];
        DFA_PRODUCTION__SET_VALID(_ROUNDFLOAT_REGFPR1_, _RoundFloat_regFPR1__rule, c)
    }
}
void  State::_sub_Op_SafePoint(const Node *n){
    {
      unsigned int c = 125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, safePoint_poll_rule, c)
    }
}
void  State::_sub_Op_SinD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10016 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 10513 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+1800;
        DFA_PRODUCTION__SET_VALID(REGD, sinD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, sinD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, sinD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 10006 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10524 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+1800;
        DFA_PRODUCTION__SET_VALID(REGDPR1, sinDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, sinDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, sinDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, sinDPR_reg_rule, c)
    }
}
void  State::_sub_Op_SqrtD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMD) &&
        (
#line 845 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=2
#line 10538 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, sqrtD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, sqrtD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADD_MEMORY_) &&
        (
#line 833 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=2
#line 10549 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, sqrtD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, sqrtD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 821 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseSSE>=2
#line 10566 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, sqrtD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, sqrtD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, sqrtD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_IMMF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_IMMF_];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D_IMMF__, _SqrtD__ConvF2D_immF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D__LOADF_MEMORY__) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D__LOADF_MEMORY__];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D__LOADF_MEMORY___, _SqrtD__ConvF2D__LoadF_memory____rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _CONVF2D_REGF_) ) {
      unsigned int c = _kids[0]->_cost[_CONVF2D_REGF_];
        DFA_PRODUCTION__SET_VALID(_SQRTD__CONVF2D_REGF__, _SqrtD__ConvF2D_regF___rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) &&
        (
#line 10090 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10595 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, sqrtDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, sqrtDPR_reg_rule, c)
    }
}
void  State::_sub_Op_StoreB(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmB_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], XREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[XREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeB_rule, c)
      }
    }
}
void  State::_sub_Op_StoreC(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI16) &&
        (
#line 6977 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseStoreImmI16
#line 10621 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI16]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI16_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[EREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeC_rule, c)
      }
    }
}
void  State::_sub_Op_StoreCM(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI8]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmCM_rule, c)
    }
}
void  State::_sub_Op_StorePConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGP_EREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EAXREGP_EREGP]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storePConditional_rule, c)
    }
}
void  State::_sub_Op_StoreIConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EAXREGI_EREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EAXREGI_EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storeIConditional_rule, c)
    }
}
void  State::_sub_Op_StoreLConditional(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _BINARY_EADXREGL_EBCXREGL) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_BINARY_EADXREGL_EBCXREGL]+100;
        DFA_PRODUCTION__SET_VALID(EFLAGSREG, storeLConditional_rule, c)
    }
}
void  State::_sub_Op_StoreD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__) &&
        (
#line 9739 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10662 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE__ADDD_REGDPR__LOADD_MEMORY__]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addDPR_mem_reg_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_) &&
        (
#line 9739 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10671 "../generated/adfiles/dfa_x86_32.cpp"
) && /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE__ADDD__LOADD_MEMORY__REGDPR_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addDPR_mem_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 7084 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 10682 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeD_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDDOUBLE_REGDPR1_) &&
        (
#line 7071 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10693 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDDOUBLE_REGDPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeDPR_rounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGDPR1) &&
        (
#line 7059 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10704 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGDPR1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeDPR_rule, c)
      }
    }
}
void  State::_sub_Op_StoreF(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMF) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMF]+50;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMFPR) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMFPR]+50;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVD2F_REGDPR1_) &&
        (
#line 7145 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 10727 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVD2F_REGDPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_Drounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ROUNDFLOAT_REGFPR1_) &&
        (
#line 7133 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 10738 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ROUNDFLOAT_REGFPR1_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_rounded_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGFPR1) &&
        (
#line 7121 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0
#line 10749 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGFPR1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeFPR_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 7097 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 10760 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGF]+95;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeF_rule, c)
      }
    }
}
void  State::_sub_Op_StoreI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__IMMI]+125;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI_EREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI_EREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _XORI__LOADI_MEMORY__EREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_XORI__LOADI_MEMORY__EREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, xorI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI_EREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI_EREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ORI__LOADI_MEMORY__EREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ORI__LOADI_MEMORY__EREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, orI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI_EREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI_EREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ANDI__LOADI_MEMORY__EREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ANDI__LOADI_MEMORY__EREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, andI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI8) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI8]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _RSHIFTI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_RSHIFTI__LOADI_MEMORY__IMMI1]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, sarI_mem_1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _SUBI__LOADI_MEMORY__EREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_SUBI__LOADI_MEMORY__EREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, subI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI_M1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI_M1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, decI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI1) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI1]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, incI_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__IMMI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__IMMI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI_EREGI__LOADI_MEMORY_) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[1]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI_EREGI__LOADI_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_eReg_0_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _ADDI__LOADI_MEMORY__EREGI) &&
        /*dst*/(_kids[0]->_leaf == _kids[1]->_kids[0]->_kids[0]->_leaf) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_ADDI__LOADI_MEMORY__EREGI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, addI_mem_eReg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMI]+150;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], _CONVL2I_EREGL_) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[_CONVL2I_EREGL_]+100;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL2I_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[EREGI]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeI_rule, c)
      }
    }
}
void  State::_sub_Op_StoreL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 6934 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((StoreLNode*)n)->require_atomic_access()
#line 10910 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[EREGL]+360;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeLX_reg_volatile_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], STACKSLOTL) &&
        (
#line 6918 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2 && ((StoreLNode*)n)->require_atomic_access()
#line 10919 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[STACKSLOTL]+380;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeLX_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], STACKSLOTL) &&
        (
#line 6905 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1 && ((StoreLNode*)n)->require_atomic_access()
#line 10930 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[STACKSLOTL]+400;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_volatile_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], LONG_MEMORY) && STATE__VALID_CHILD(_kids[1], EREGL) &&
        (
#line 6878 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
!((StoreLNode*)n)->require_atomic_access()
#line 10941 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[LONG_MEMORY]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeL_rule, c)
      }
    }
}
void  State::_sub_Op_StoreP(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], IMMP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[IMMP]+150;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeImmP_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], ANYREGP) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[ANYREGP]+125;
      if (STATE__NOT_YET_VALID(UNIVERSE) || _cost[UNIVERSE] > c) {
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeP_rule, c)
      }
    }
}
void  State::_sub_Op_StrComp(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ECXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EDXREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ECXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EDXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_compare_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_compare_rule, c)
    }
}
void  State::_sub_Op_StrEquals(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_ESIREGP) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_ESIREGP]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_equals_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_equals_rule, c)
    }
}
void  State::_sub_Op_StrIndexOf(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_EAXREGI) &&
        (
#line 12037 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE42Intrinsics
#line 11000 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_EAXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _BINARY_EDIREGP_EDXREGI) && STATE__VALID_CHILD(_kids[1], _BINARY_ESIREGP_IMMI) &&
        (
#line 12010 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE42Intrinsics
#line 11020 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_BINARY_EDIREGP_EDXREGI]+_kids[1]->_cost[_BINARY_ESIREGP_IMMI]+100;
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, string_indexof_con_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, string_indexof_con_rule, c)
      }
    }
}
void  State::_sub_Op_SubD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 394 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 11066 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
        DFA_PRODUCTION__SET_VALID(REGD, vsubD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, vsubD_imm_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, vsubD_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 382 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 11077 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vsubD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vsubD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vsubD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 370 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 11094 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, vsubD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, vsubD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, vsubD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], IMMD) &&
        (
#line 359 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 11111 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[IMMD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, subD_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, subD_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 347 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 11128 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, subD_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, subD_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 335 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=2) && (UseAVX == 0)
#line 11145 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+_kids[1]->_cost[REGD]+150;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, subD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, subD_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, subD_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], _MULD_REGDPR_REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9898 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
 UseSSE<=1 
#line 11162 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[_MULD_REGDPR_REGDPR]+_kids[1]->_cost[REGDPR]+250;
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_mulDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_mulDPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], _LOADD_MEMORY_) &&
        (
#line 9663 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE <=1
#line 11174 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[_LOADD_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_reg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_reg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR];
        DFA_PRODUCTION__SET_VALID(_SUBD_REGDPR_REGDPR, _SubD_regDPR_regDPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR) && STATE__VALID_CHILD(_kids[1], REGDPR) &&
        (
#line 9635 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE <=1
#line 11198 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR]+_kids[1]->_cost[REGDPR]+150;
      if (STATE__NOT_YET_VALID(REGDPR) || _cost[REGDPR] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR1) || _cost[REGDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR1, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGDPR2) || _cost[REGDPR2] > c) {
        DFA_PRODUCTION__SET_VALID(REGDPR2, subDPR_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGNOTDPR1) || _cost[REGNOTDPR1] > c) {
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, subDPR_reg_rule, c)
      }
    }
}
void  State::_sub_Op_SubF(const Node *n){
    bool Compile__current____select_24_bit_instr__ = Compile::current()->select_24_bit_instr();
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 323 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 11221 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
        DFA_PRODUCTION__SET_VALID(REGF, vsubF_imm_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 311 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 11230 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vsubF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 299 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
UseAVX > 0
#line 11241 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, vsubF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], IMMF) &&
        (
#line 288 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 11252 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[IMMF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], _LOADF_MEMORY_) &&
        (
#line 276 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 11263 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[_LOADF_MEMORY_]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) && STATE__VALID_CHILD(_kids[1], REGF) &&
        (
#line 264 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86.ad"
(UseSSE>=1) && (UseAVX == 0)
#line 11274 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+_kids[1]->_cost[REGF]+150;
      if (STATE__NOT_YET_VALID(REGF) || _cost[REGF] > c) {
        DFA_PRODUCTION__SET_VALID(REGF, subF_reg_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR];
        DFA_PRODUCTION__SET_VALID(_SUBF_REGFPR_REGFPR, _SubF_regFPR_regFPR_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10534 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && !Compile__current____select_24_bit_instr__
#line 11289 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(REGFPR, subFPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGFPR1, subFPR_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGFPR) && STATE__VALID_CHILD(_kids[1], REGFPR) &&
        (
#line 10521 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE==0 && Compile__current____select_24_bit_instr__
#line 11299 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGFPR]+_kids[1]->_cost[REGFPR]+100;
        DFA_PRODUCTION__SET_VALID(STACKSLOTF, subFPR24_reg_rule, c)
      if (STATE__NOT_YET_VALID(REGFPR) || _cost[REGFPR] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR, loadSSF_rule, c+125)
      }
      if (STATE__NOT_YET_VALID(REGFPR1) || _cost[REGFPR1] > c+125) {
        DFA_PRODUCTION__SET_VALID(REGFPR1, loadSSF_rule, c+125)
      }
    }
}
void  State::_sub_Op_SubI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], NCXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[NCXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_NCXREGI_NCXREGI, _SubI_ncxRegI_ncxRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI_32) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI_32]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI_32_ECXREGI, _SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_ECXREGI, _SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[EREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, negI_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, negI_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], IMMI0) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI_IMMI0_EREGI, _SubI_immI0_eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_SUBI__LOADI_MEMORY__EREGI, _SubI__LoadI_memory__eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, subI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, subI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_SubL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMML0) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[IMML0]+_kids[1]->_cost[EREGL]+300;
        DFA_PRODUCTION__SET_VALID(EREGL, negL_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, negL_eReg_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, negL_eReg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, subL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, subL_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, subL_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_TailCall(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EBXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EBXREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, TailCalljmpInd_rule, c)
    }
}
void  State::_sub_Op_TailJump(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGP_NO_EBP) && STATE__VALID_CHILD(_kids[1], EAXREGP) ) {
      unsigned int c = _kids[0]->_cost[EREGP_NO_EBP]+_kids[1]->_cost[EAXREGP]+300;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, tailjmpInd_rule, c)
    }
}
void  State::_sub_Op_TanD(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 10057 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 11536 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
        DFA_PRODUCTION__SET_VALID(REGD, tanD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, tanD_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, tanD_reg_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGDPR1) &&
        (
#line 10048 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE<=1
#line 11547 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGDPR1]+100;
        DFA_PRODUCTION__SET_VALID(REGDPR1, tanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR, tanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGDPR2, tanDPR_reg_rule, c)
        DFA_PRODUCTION__SET_VALID(REGNOTDPR1, tanDPR_reg_rule, c)
    }
}
void  State::_sub_Op_ThreadLocal(const Node *n){
    {
      unsigned int c = 100;
        DFA_PRODUCTION__SET_VALID(EREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTP, storeSSP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(ANYREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(EREGP_NO_EBP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(INDIRECT_WIN95_SAFE, tlsLoadP_rule, c+100+100)
        DFA_PRODUCTION__SET_VALID(EBXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(PREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(NABXREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_REGP, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_INDIRECT, tlsLoadP_rule, c+100)
        DFA_PRODUCTION__SET_VALID(LOAD_LONG_MEMORY, load_long_indirect_rule, c+100)
        DFA_PRODUCTION__SET_VALID(EDIREGP, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(INDIRECT, tlsLoadP_rule, c)
        DFA_PRODUCTION__SET_VALID(MEMORY, indirect_rule, c)
        DFA_PRODUCTION__SET_VALID(LONG_MEMORY, indirect_rule, c)
    }
}
void  State::_sub_Op_URShiftI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI_ECXREGI, _URShiftI_ncxRegI_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_EREGI_IMMI1, _URShiftI_eRegI_immI1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI_32_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI_32_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI__SUBI_IMMI_32_ECXREGI, _URShiftI_ncxRegI__SubI_immI_32_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], NCXREGI) && STATE__VALID_CHILD(_kids[1], _SUBI_IMMI0_ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[NCXREGI]+_kids[1]->_cost[_SUBI_IMMI0_ECXREGI];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_NCXREGI__SUBI_IMMI0_ECXREGI, _URShiftI_ncxRegI__SubI_immI0_eCXRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI8];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_EREGI_IMMI8, _URShiftI_eRegI_immI8_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI_M1];
        DFA_PRODUCTION__SET_VALID(_URSHIFTI_EREGI_IMMI_M1, _URShiftI_eRegI_immI_M1_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[ECXREGI]+100;
        DFA_PRODUCTION__SET_VALID(EREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI8) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI8]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, shrI_eReg_1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, shrI_eReg_1_rule, c)
      }
    }
}
void  State::_sub_Op_URShiftL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], ECXREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[ECXREGI]+600;
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_CL_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_CL_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_32_63) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_32_63]+300;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_32_63_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_32_63_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMMI_1_31) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMMI_1_31]+200;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, shrL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, shrL_eReg_1_31_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, shrL_eReg_1_31_rule, c)
      }
    }
}
void  State::_sub_Op_XorI(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[IMMI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__IMMI, _XorI__LoadI_memory__immI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_];
        DFA_PRODUCTION__SET_VALID(_XORI_EREGI__LOADI_MEMORY_, _XorI_eRegI__LoadI_memory__rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI];
        DFA_PRODUCTION__SET_VALID(_XORI__LOADI_MEMORY__EREGI, _XorI__LoadI_memory__eRegI_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], _LOADI_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[_LOADI_MEMORY_]+_kids[1]->_cost[EREGI]+125;
        DFA_PRODUCTION__SET_VALID(EREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], _LOADI_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[_LOADI_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], IMMI_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[IMMI_M1]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) && STATE__VALID_CHILD(_kids[1], EREGI) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+_kids[1]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(EREGI) || _cost[EREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTI) || _cost[STACKSLOTI] > c+100) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTI, storeSSI_rule, c+100)
      }
      if (STATE__NOT_YET_VALID(XREGI) || _cost[XREGI] > c) {
        DFA_PRODUCTION__SET_VALID(XREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EAXREGI) || _cost[EAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EAXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NCXREGI) || _cost[NCXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NCXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBXREGI) || _cost[EBXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EBXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NADXREGI) || _cost[NADXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NADXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ECXREGI) || _cost[ECXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ECXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(NAXREGI) || _cost[NAXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(NAXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDXREGI) || _cost[EDXREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDXREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EDIREGI) || _cost[EDIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(EDIREGI, xorI_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(ESIREGI) || _cost[ESIREGI] > c) {
        DFA_PRODUCTION__SET_VALID(ESIREGI, xorI_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_XorL(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], _LOADL_LOAD_LONG_MEMORY_) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[_LOADL_LOAD_LONG_MEMORY_]+_kids[1]->_cost[EREGL]+125;
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_mem_0_rule, c)
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_mem_0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], _LOADL_LOAD_LONG_MEMORY_) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[_LOADL_LOAD_LONG_MEMORY_]+125;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_mem_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_mem_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_imm_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_imm_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], IMML_M1) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[IMML_M1]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_im1_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_im1_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], EREGL) && STATE__VALID_CHILD(_kids[1], EREGL) ) {
      unsigned int c = _kids[0]->_cost[EREGL]+_kids[1]->_cost[EREGL]+100;
      if (STATE__NOT_YET_VALID(EREGL) || _cost[EREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EREGL, xorl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(STACKSLOTL) || _cost[STACKSLOTL] > c+200) {
        DFA_PRODUCTION__SET_VALID(STACKSLOTL, storeSSL_rule, c+200)
      }
      if (STATE__NOT_YET_VALID(EADXREGL) || _cost[EADXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EADXREGL, xorl_eReg_rule, c)
      }
      if (STATE__NOT_YET_VALID(EBCXREGL) || _cost[EBCXREGL] > c) {
        DFA_PRODUCTION__SET_VALID(EBCXREGL, xorl_eReg_rule, c)
      }
    }
}
void  State::_sub_Op_Load8B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6341 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 11997 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(REGD, loadA8B_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, loadA8B_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, loadA8B_rule, c)
    }
}
void  State::_sub_Op_Load4C(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6365 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12010 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(REGD, loadA4C_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, loadA4C_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, loadA4C_rule, c)
    }
}
void  State::_sub_Op_Load4S(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6353 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12023 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(REGD, loadA4S_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, loadA4S_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, loadA4S_rule, c)
    }
}
void  State::_sub_Op_Load2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6377 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12036 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+125;
        DFA_PRODUCTION__SET_VALID(REGD, load2IU_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, load2IU_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, load2IU_rule, c)
    }
}
void  State::_sub_Op_Load2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) &&
        (
#line 6389 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12049 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+145;
        DFA_PRODUCTION__SET_VALID(REGD, loadA2F_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, loadA2F_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, loadA2F_rule, c)
    }
}
void  State::_sub_Op_Store8B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 7012 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12062 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeA8B_rule, c)
    }
}
void  State::_sub_Op_Store4C(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 7024 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12073 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeA4C_rule, c)
    }
}
void  State::_sub_Op_Store2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 7036 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12084 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeA2I_rule, c)
    }
}
void  State::_sub_Op_Store2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], MEMORY) && STATE__VALID_CHILD(_kids[1], REGD) &&
        (
#line 7109 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=1
#line 12095 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[MEMORY]+_kids[1]->_cost[REGD]+145;
        DFA_PRODUCTION__SET_VALID(UNIVERSE, storeA2F_rule, c)
    }
}
void  State::_sub_Op_Replicate8B(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 11816 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12106 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(REGD, Repl8B_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, Repl8B_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, Repl8B_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11801 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12117 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl8B_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl8B_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl8B_eRegI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11784 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12134 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl8B_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl8B_reg_rule, c)
      }
    }
}
void  State::_sub_Op_Replicate4S(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 11851 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12153 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(REGD, Repl4S_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, Repl4S_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, Repl4S_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11838 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12164 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl4S_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl4S_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl4S_eRegI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11827 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12181 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl4S_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl4S_reg_rule, c)
      }
    }
}
void  State::_sub_Op_Replicate4C(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 11886 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12200 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(REGD, Repl4C_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, Repl4C_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, Repl4C_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11873 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12211 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl4C_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl4C_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl4C_eRegI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11862 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12228 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl4C_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl4C_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl4C_reg_rule, c)
      }
    }
}
void  State::_sub_Op_Replicate2I(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMI0) &&
        (
#line 11921 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12247 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMI0]+100;
        DFA_PRODUCTION__SET_VALID(REGD, Repl2I_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, Repl2I_immI0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, Repl2I_immI0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], EREGI) &&
        (
#line 11908 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12258 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[EREGI]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl2I_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl2I_eRegI_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl2I_eRegI_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11897 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12275 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl2I_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl2I_reg_rule, c)
      }
    }
}
void  State::_sub_Op_Replicate2F(const Node *n){
    if( STATE__VALID_CHILD(_kids[0], IMMF0) &&
        (
#line 11954 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12294 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[IMMF0]+100;
        DFA_PRODUCTION__SET_VALID(REGD, Repl2F_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD6, Repl2F_immF0_rule, c)
        DFA_PRODUCTION__SET_VALID(REGD7, Repl2F_immF0_rule, c)
    }
    if( STATE__VALID_CHILD(_kids[0], REGF) &&
        (
#line 11943 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12305 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGF]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl2F_regF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl2F_regF_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl2F_regF_rule, c)
      }
    }
    if( STATE__VALID_CHILD(_kids[0], REGD) &&
        (
#line 11932 "/builddir/build/BUILD/icedtea6-1.13.8/openjdk/hotspot/src/cpu/x86/vm/x86_32.ad"
UseSSE>=2
#line 12322 "../generated/adfiles/dfa_x86_32.cpp"
) ) {
      unsigned int c = _kids[0]->_cost[REGD]+100;
      if (STATE__NOT_YET_VALID(REGD) || _cost[REGD] > c) {
        DFA_PRODUCTION__SET_VALID(REGD, Repl2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD6) || _cost[REGD6] > c) {
        DFA_PRODUCTION__SET_VALID(REGD6, Repl2F_reg_rule, c)
      }
      if (STATE__NOT_YET_VALID(REGD7) || _cost[REGD7] > c) {
        DFA_PRODUCTION__SET_VALID(REGD7, Repl2F_reg_rule, c)
      }
    }
}
bool State::DFA(int opcode, const Node *n) {
  switch(opcode) {
  case Op_RegI: { _sub_Op_RegI(n);
    break;
  }
  case Op_RegP: { _sub_Op_RegP(n);
    break;
  }
  case Op_RegF: { _sub_Op_RegF(n);
    break;
  }
  case Op_RegD: { _sub_Op_RegD(n);
    break;
  }
  case Op_RegL: { _sub_Op_RegL(n);
    break;
  }
  case Op_RegFlags: { _sub_Op_RegFlags(n);
    break;
  }
  case Op_AbsD: { _sub_Op_AbsD(n);
    break;
  }
  case Op_AbsF: { _sub_Op_AbsF(n);
    break;
  }
  case Op_AddD: { _sub_Op_AddD(n);
    break;
  }
  case Op_AddF: { _sub_Op_AddF(n);
    break;
  }
  case Op_AddI: { _sub_Op_AddI(n);
    break;
  }
  case Op_AddL: { _sub_Op_AddL(n);
    break;
  }
  case Op_AddP: { _sub_Op_AddP(n);
    break;
  }
  case Op_AndI: { _sub_Op_AndI(n);
    break;
  }
  case Op_AndL: { _sub_Op_AndL(n);
    break;
  }
  case Op_AryEq: { _sub_Op_AryEq(n);
    break;
  }
  case Op_AtanD: { _sub_Op_AtanD(n);
    break;
  }
  case Op_Binary: { _sub_Op_Binary(n);
    break;
  }
  case Op_Bool: { _sub_Op_Bool(n);
    break;
  }
  case Op_ReverseBytesI: { _sub_Op_ReverseBytesI(n);
    break;
  }
  case Op_ReverseBytesL: { _sub_Op_ReverseBytesL(n);
    break;
  }
  case Op_ReverseBytesUS: { _sub_Op_ReverseBytesUS(n);
    break;
  }
  case Op_ReverseBytesS: { _sub_Op_ReverseBytesS(n);
    break;
  }
  case Op_CallDynamicJava: { _sub_Op_CallDynamicJava(n);
    break;
  }
  case Op_CallLeaf: { _sub_Op_CallLeaf(n);
    break;
  }
  case Op_CallLeafNoFP: { _sub_Op_CallLeafNoFP(n);
    break;
  }
  case Op_CallRuntime: { _sub_Op_CallRuntime(n);
    break;
  }
  case Op_CallStaticJava: { _sub_Op_CallStaticJava(n);
    break;
  }
  case Op_CastII: { _sub_Op_CastII(n);
    break;
  }
  case Op_CastX2P: { _sub_Op_CastX2P(n);
    break;
  }
  case Op_CastP2X: { _sub_Op_CastP2X(n);
    break;
  }
  case Op_CastPP: { _sub_Op_CastPP(n);
    break;
  }
  case Op_CheckCastPP: { _sub_Op_CheckCastPP(n);
    break;
  }
  case Op_ClearArray: { _sub_Op_ClearArray(n);
    break;
  }
  case Op_CMoveD: { _sub_Op_CMoveD(n);
    break;
  }
  case Op_CMoveF: { _sub_Op_CMoveF(n);
    break;
  }
  case Op_CMoveI: { _sub_Op_CMoveI(n);
    break;
  }
  case Op_CMoveL: { _sub_Op_CMoveL(n);
    break;
  }
  case Op_CMoveP: { _sub_Op_CMoveP(n);
    break;
  }
  case Op_CmpD: { _sub_Op_CmpD(n);
    break;
  }
  case Op_CmpD3: { _sub_Op_CmpD3(n);
    break;
  }
  case Op_CmpF: { _sub_Op_CmpF(n);
    break;
  }
  case Op_CmpF3: { _sub_Op_CmpF3(n);
    break;
  }
  case Op_CmpI: { _sub_Op_CmpI(n);
    break;
  }
  case Op_CmpL: { _sub_Op_CmpL(n);
    break;
  }
  case Op_CmpL3: { _sub_Op_CmpL3(n);
    break;
  }
  case Op_CmpLTMask: { _sub_Op_CmpLTMask(n);
    break;
  }
  case Op_CmpP: { _sub_Op_CmpP(n);
    break;
  }
  case Op_CmpU: { _sub_Op_CmpU(n);
    break;
  }
  case Op_CompareAndSwapI: { _sub_Op_CompareAndSwapI(n);
    break;
  }
  case Op_CompareAndSwapL: { _sub_Op_CompareAndSwapL(n);
    break;
  }
  case Op_CompareAndSwapP: { _sub_Op_CompareAndSwapP(n);
    break;
  }
  case Op_ConD: { _sub_Op_ConD(n);
    break;
  }
  case Op_ConF: { _sub_Op_ConF(n);
    break;
  }
  case Op_ConI: { _sub_Op_ConI(n);
    break;
  }
  case Op_ConL: { _sub_Op_ConL(n);
    break;
  }
  case Op_ConP: { _sub_Op_ConP(n);
    break;
  }
  case Op_Conv2B: { _sub_Op_Conv2B(n);
    break;
  }
  case Op_ConvD2F: { _sub_Op_ConvD2F(n);
    break;
  }
  case Op_ConvD2I: { _sub_Op_ConvD2I(n);
    break;
  }
  case Op_ConvD2L: { _sub_Op_ConvD2L(n);
    break;
  }
  case Op_ConvF2D: { _sub_Op_ConvF2D(n);
    break;
  }
  case Op_ConvF2I: { _sub_Op_ConvF2I(n);
    break;
  }
  case Op_ConvF2L: { _sub_Op_ConvF2L(n);
    break;
  }
  case Op_ConvI2D: { _sub_Op_ConvI2D(n);
    break;
  }
  case Op_ConvI2F: { _sub_Op_ConvI2F(n);
    break;
  }
  case Op_ConvI2L: { _sub_Op_ConvI2L(n);
    break;
  }
  case Op_ConvL2D: { _sub_Op_ConvL2D(n);
    break;
  }
  case Op_ConvL2F: { _sub_Op_ConvL2F(n);
    break;
  }
  case Op_ConvL2I: { _sub_Op_ConvL2I(n);
    break;
  }
  case Op_CosD: { _sub_Op_CosD(n);
    break;
  }
  case Op_CountedLoopEnd: { _sub_Op_CountedLoopEnd(n);
    break;
  }
  case Op_CountLeadingZerosI: { _sub_Op_CountLeadingZerosI(n);
    break;
  }
  case Op_CountLeadingZerosL: { _sub_Op_CountLeadingZerosL(n);
    break;
  }
  case Op_CountTrailingZerosI: { _sub_Op_CountTrailingZerosI(n);
    break;
  }
  case Op_CountTrailingZerosL: { _sub_Op_CountTrailingZerosL(n);
    break;
  }
  case Op_CreateEx: { _sub_Op_CreateEx(n);
    break;
  }
  case Op_DivD: { _sub_Op_DivD(n);
    break;
  }
  case Op_DivF: { _sub_Op_DivF(n);
    break;
  }
  case Op_DivI: { _sub_Op_DivI(n);
    break;
  }
  case Op_DivL: { _sub_Op_DivL(n);
    break;
  }
  case Op_DivModI: { _sub_Op_DivModI(n);
    break;
  }
  case Op_ExpD: { _sub_Op_ExpD(n);
    break;
  }
  case Op_FastLock: { _sub_Op_FastLock(n);
    break;
  }
  case Op_FastUnlock: { _sub_Op_FastUnlock(n);
    break;
  }
  case Op_Goto: { _sub_Op_Goto(n);
    break;
  }
  case Op_Halt: { _sub_Op_Halt(n);
    break;
  }
  case Op_If: { _sub_Op_If(n);
    break;
  }
  case Op_Jump: { _sub_Op_Jump(n);
    break;
  }
  case Op_LShiftI: { _sub_Op_LShiftI(n);
    break;
  }
  case Op_LShiftL: { _sub_Op_LShiftL(n);
    break;
  }
  case Op_LoadB: { _sub_Op_LoadB(n);
    break;
  }
  case Op_LoadUB: { _sub_Op_LoadUB(n);
    break;
  }
  case Op_LoadUS: { _sub_Op_LoadUS(n);
    break;
  }
  case Op_LoadD: { _sub_Op_LoadD(n);
    break;
  }
  case Op_LoadF: { _sub_Op_LoadF(n);
    break;
  }
  case Op_LoadI: { _sub_Op_LoadI(n);
    break;
  }
  case Op_LoadUI2L: { _sub_Op_LoadUI2L(n);
    break;
  }
  case Op_LoadKlass: { _sub_Op_LoadKlass(n);
    break;
  }
  case Op_LoadL: { _sub_Op_LoadL(n);
    break;
  }
  case Op_LoadPLocked: { _sub_Op_LoadPLocked(n);
    break;
  }
  case Op_LoadLLocked: { _sub_Op_LoadLLocked(n);
    break;
  }
  case Op_LoadP: { _sub_Op_LoadP(n);
    break;
  }
  case Op_LoadRange: { _sub_Op_LoadRange(n);
    break;
  }
  case Op_LoadS: { _sub_Op_LoadS(n);
    break;
  }
  case Op_LogD: { _sub_Op_LogD(n);
    break;
  }
  case Op_Log10D: { _sub_Op_Log10D(n);
    break;
  }
  case Op_LoopLimit: { _sub_Op_LoopLimit(n);
    break;
  }
  case Op_MaxI: { _sub_Op_MaxI(n);
    break;
  }
  case Op_MemBarAcquire: { _sub_Op_MemBarAcquire(n);
    break;
  }
  case Op_MemBarAcquireLock: { _sub_Op_MemBarAcquireLock(n);
    break;
  }
  case Op_MemBarRelease: { _sub_Op_MemBarRelease(n);
    break;
  }
  case Op_MemBarReleaseLock: { _sub_Op_MemBarReleaseLock(n);
    break;
  }
  case Op_MemBarVolatile: { _sub_Op_MemBarVolatile(n);
    break;
  }
  case Op_MemBarStoreStore: { _sub_Op_MemBarStoreStore(n);
    break;
  }
  case Op_MinI: { _sub_Op_MinI(n);
    break;
  }
  case Op_ModD: { _sub_Op_ModD(n);
    break;
  }
  case Op_ModF: { _sub_Op_ModF(n);
    break;
  }
  case Op_ModI: { _sub_Op_ModI(n);
    break;
  }
  case Op_ModL: { _sub_Op_ModL(n);
    break;
  }
  case Op_MoveI2F: { _sub_Op_MoveI2F(n);
    break;
  }
  case Op_MoveF2I: { _sub_Op_MoveF2I(n);
    break;
  }
  case Op_MoveL2D: { _sub_Op_MoveL2D(n);
    break;
  }
  case Op_MoveD2L: { _sub_Op_MoveD2L(n);
    break;
  }
  case Op_MulD: { _sub_Op_MulD(n);
    break;
  }
  case Op_MulF: { _sub_Op_MulF(n);
    break;
  }
  case Op_MulI: { _sub_Op_MulI(n);
    break;
  }
  case Op_MulL: { _sub_Op_MulL(n);
    break;
  }
  case Op_NegD: { _sub_Op_NegD(n);
    break;
  }
  case Op_NegF: { _sub_Op_NegF(n);
    break;
  }
  case Op_OrI: { _sub_Op_OrI(n);
    break;
  }
  case Op_OrL: { _sub_Op_OrL(n);
    break;
  }
  case Op_PartialSubtypeCheck: { _sub_Op_PartialSubtypeCheck(n);
    break;
  }
  case Op_PopCountI: { _sub_Op_PopCountI(n);
    break;
  }
  case Op_PopCountL: { _sub_Op_PopCountL(n);
    break;
  }
  case Op_PowD: { _sub_Op_PowD(n);
    break;
  }
  case Op_PrefetchAllocation: { _sub_Op_PrefetchAllocation(n);
    break;
  }
  case Op_PrefetchRead: { _sub_Op_PrefetchRead(n);
    break;
  }
  case Op_PrefetchWrite: { _sub_Op_PrefetchWrite(n);
    break;
  }
  case Op_RShiftI: { _sub_Op_RShiftI(n);
    break;
  }
  case Op_RShiftL: { _sub_Op_RShiftL(n);
    break;
  }
  case Op_Rethrow: { _sub_Op_Rethrow(n);
    break;
  }
  case Op_Return: { _sub_Op_Return(n);
    break;
  }
  case Op_RoundDouble: { _sub_Op_RoundDouble(n);
    break;
  }
  case Op_RoundFloat: { _sub_Op_RoundFloat(n);
    break;
  }
  case Op_SafePoint: { _sub_Op_SafePoint(n);
    break;
  }
  case Op_SinD: { _sub_Op_SinD(n);
    break;
  }
  case Op_SqrtD: { _sub_Op_SqrtD(n);
    break;
  }
  case Op_StoreB: { _sub_Op_StoreB(n);
    break;
  }
  case Op_StoreC: { _sub_Op_StoreC(n);
    break;
  }
  case Op_StoreCM: { _sub_Op_StoreCM(n);
    break;
  }
  case Op_StorePConditional: { _sub_Op_StorePConditional(n);
    break;
  }
  case Op_StoreIConditional: { _sub_Op_StoreIConditional(n);
    break;
  }
  case Op_StoreLConditional: { _sub_Op_StoreLConditional(n);
    break;
  }
  case Op_StoreD: { _sub_Op_StoreD(n);
    break;
  }
  case Op_StoreF: { _sub_Op_StoreF(n);
    break;
  }
  case Op_StoreI: { _sub_Op_StoreI(n);
    break;
  }
  case Op_StoreL: { _sub_Op_StoreL(n);
    break;
  }
  case Op_StoreP: { _sub_Op_StoreP(n);
    break;
  }
  case Op_StrComp: { _sub_Op_StrComp(n);
    break;
  }
  case Op_StrEquals: { _sub_Op_StrEquals(n);
    break;
  }
  case Op_StrIndexOf: { _sub_Op_StrIndexOf(n);
    break;
  }
  case Op_SubD: { _sub_Op_SubD(n);
    break;
  }
  case Op_SubF: { _sub_Op_SubF(n);
    break;
  }
  case Op_SubI: { _sub_Op_SubI(n);
    break;
  }
  case Op_SubL: { _sub_Op_SubL(n);
    break;
  }
  case Op_TailCall: { _sub_Op_TailCall(n);
    break;
  }
  case Op_TailJump: { _sub_Op_TailJump(n);
    break;
  }
  case Op_TanD: { _sub_Op_TanD(n);
    break;
  }
  case Op_ThreadLocal: { _sub_Op_ThreadLocal(n);
    break;
  }
  case Op_URShiftI: { _sub_Op_URShiftI(n);
    break;
  }
  case Op_URShiftL: { _sub_Op_URShiftL(n);
    break;
  }
  case Op_XorI: { _sub_Op_XorI(n);
    break;
  }
  case Op_XorL: { _sub_Op_XorL(n);
    break;
  }
  case Op_Load8B: { _sub_Op_Load8B(n);
    break;
  }
  case Op_Load4C: { _sub_Op_Load4C(n);
    break;
  }
  case Op_Load4S: { _sub_Op_Load4S(n);
    break;
  }
  case Op_Load2I: { _sub_Op_Load2I(n);
    break;
  }
  case Op_Load2F: { _sub_Op_Load2F(n);
    break;
  }
  case Op_Store8B: { _sub_Op_Store8B(n);
    break;
  }
  case Op_Store4C: { _sub_Op_Store4C(n);
    break;
  }
  case Op_Store2I: { _sub_Op_Store2I(n);
    break;
  }
  case Op_Store2F: { _sub_Op_Store2F(n);
    break;
  }
  case Op_Replicate8B: { _sub_Op_Replicate8B(n);
    break;
  }
  case Op_Replicate4S: { _sub_Op_Replicate4S(n);
    break;
  }
  case Op_Replicate4C: { _sub_Op_Replicate4C(n);
    break;
  }
  case Op_Replicate2I: { _sub_Op_Replicate2I(n);
    break;
  }
  case Op_Replicate2F: { _sub_Op_Replicate2F(n);
    break;
  }
  
  default:
    tty->print("Default case invoked for: \n");
    tty->print("   opcode  = %d, \"%s\"\n", opcode, NodeClassNames[opcode]);
    return false;
  }
  return true;
}
